//
// CC-007 - Puffer Train
// This is coded fast, loose, and unsafe as hell.
// For the love of god, don't code a real game like this, okay?
//
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "raylib.h"
#include "fastprng.h"


#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))

#define SCREEN_W          1600
#define SCREEN_H           900
#define GLSL_VERSION       330

#define MAX_ACTORS        1280
#define MAX_ANIMATIONS       4
#define MAX_FRAMES          16
#define MAX_SFX             32
#define MAX_KELP            48

#define PURE_GREEN       (Color){   0, 255,   0, 255 }
#define PURE_BLUE        (Color){   0,   0, 255, 255 }
#define PURE_YELLOW      (Color){ 255, 255,   0, 255 }

#define SCORE_PINK       (Color){ 242, 103, 119, 255 }
#define SCORE_ORANGE     (Color){ 255, 161,   0, 255 }
#define SCORE_GREEN      (Color){ 145, 240,   0, 255 }

#define WATER            (Color){  25, 113, 180, 255 }
#define SKY_BLUE         (Color){  25, 113, 180, 255 }
#define EYE_ORANGE       (Color){ 215, 115,   0, 255 }
#define CHILL_CYAN       (Color){  22, 230, 255, 255 }
#define KELP_GREEN       (Color){ 131, 231, 107, 255 }
#define KELP_BLUE        (Color){   0, 101, 203, 255 }
#define SKILL_PINK       (Color){ 235, 123, 217, 255 }


#define SESSION_TIME     10800
#define MOVE_SCALE        4.00
#define TILE_SIZE        16.00
#define ACTOR_SCALE       4.00
#define GRAVITY_PULL      0.10
#define INFINITE         99999


//#define USE_RTMIDI
#define USE_TEXTBOX


/// STANDARD FEATURE SETS ///


fastPRNG::fastXS64 fastR;                          // fastPRNG, because Raylib's is not so good

#ifdef USE_RTMIDI
    #include <iostream>
    #include <cstdlib>
    #include "RtMidi.h"

    #define MAX_KNOBS 17

    class device_struct {
        public:
        bool  mode;                                // 0 = Absolute, 1 = Relative
        int   id;                                  // MIDI code for this knob
        float r_min;                               // Raw minimum (input)
        float r_max;                               // Raw maximum (input)
        float s_min;                               // Scaled minimum (output)
        float s_max;                               // Scaled maximum (output)
        float value;                               // Scaled value for use in program
        int   input;                               // Raw value from MIDI controller
                                                   // This value persists if Relative
        float scale;                               // Used *ONLY* by Relative input to scale each tick
                        };

    class FR_midi_struct {
        public:
        bool ignore_sysex;                         // Set these flags to TRUE to ignore this message type
        bool ignore_timing;                        //
        bool ignore_active_sensing;                //

        bool keys[128];                            // Key state (pressed only)
        bool note_active;                          // **Primitive** variable for state of last key command
        int  note_key;                             // **primitive** variable for key # of last key command
        double note_freq;                          // **primitive** variable for frequency of last key command

        device_struct knobs[MAX_KNOBS];
        device_struct pads[MAX_KNOBS];
        int  total_ports;                          // Total MIDI ports, as reported by the lib
        int  current_port;                         // Port we're listening to. Defaults to zero.
        std::vector<unsigned char> message;        // Storage space for messages (later we'll queue this)
        int  msg_bytes;                            // Message byte length
        double msg_stamp;                          // Message timestamp delta
        RtMidiIn *midiin;                          // Obligatory rtMidi construct
                         };

    FR_midi_struct midi;
    void init_midi();
    void init_arturia_profile();
    void poll_midi();
    void draw_midi_knobs();
    void update_midi_knob(int slot);
    void set_knob(int slot, float new_value);
    void save_knobs();
    void load_knobs();
    void rescale_midi_device_abs(device_struct &knob, float raw_min, float raw_max, float scale_min, float scale_max);
    void rescale_midi_device_rel(device_struct &knob, float scale_min, float scale_max, float tick_scale);
#endif





#ifdef USE_TEXTBOX
    #define MAX_TEXTBOX          8

    struct textbox_struct
    {
     Rectangle pos;
     float scale;
     bool enabled;                // TRUE if this box is active
     int viewable_text;           // Number of chars currently exposed (starts at zero, counts up)
     int duration;                // Number of ticks before textbox closes. -1 if disabled
     int mode;                    // 0 = entering, 1 = displaying text, 2 = exiting
     int ticks;                   // Counts time between displaying characters
     const char *msg;
    };

    textbox_struct textbox[MAX_TEXTBOX];

    void check_textbox();
    void draw_text_box(int slot);
    void trigger_textbox(int slot, int x, int y, int w, int h, int message, int delay, int duration);
#endif






/// PROJECT-SPECIFIC FEATURE SETS ///

// Update routines (should be called per-frame, or at fixed intervals)
// Project-specific routines are listed last
//
void check_animations();
void check_shaders();
void check_time();
void check_score();
void check_actors();
void check_spawns();
void check_input();
void check_sfx_buffer();


void cleanup();
void end_game(int mode);
void show_stats();


// Spawning and actor maintenance routines
//
void kill_actor(int slot);
void kill_squid();
void kill_hook(int who);
void spawn_permanent_actors();
void spawn_weeds();
void spawn_kelp_patches();
int  spawn_actor(int type, float x, float y, float z, int cell_x, float path_x, float path_y, float path_z);
int  spawn_bullet(float x, float y, float z, int type);
int  spawn_damage(float x, float y, float z, bool type);
int  spawn_brush(int x, int y, Color col, float scale);
int  spawn_player(int x, int y, int z);
int  spawn_ray(float x, float y, float z);
int  spawn_kelp(int x, int y, Color col, float scale);
int  spawn_railcar(int x, int y, int z);
int  spawn_evil_fish(float x, float y, float z, int direction);
int  spawn_hook(float x, float y, float z, bool special);
int  spawn_shark(float x, float y, float z);
int  spawn_octopus(float x, float y, float z);
int  spawn_octopus_arm(float x, float y, float z);
int  spawn_squid(float x, float y, float z, int direction);
int  spawn_ink_blot(float x, float y, float z);
int  spawn_journal_page(float x, float y, float z, int page, bool rainbow);
int  spawn_radiance(float x, float y, float z, bool dir);
int  spawn_thruster_fire(float x, float y, float z);
int  spawn_black_bar();



void assign_animation(int who, int anim, int loops);
void kill_animation(int who);



// Drawing routines
//
void draw_actor(int slot);
void blend_helper_ex(Texture2D source,  Vector2 dest, float angle, float scale, Color tint);
void blend_helper(Texture2D source, Rectangle rect_s, Rectangle rect_d, Vector2 origin, float angle, Color tint);
void draw_summary(int mode);
void draw_tutorial();
void draw_high_score();
void draw_title_hud(const char *msg);
void draw_title();
void draw_hud();
void draw_signal(int signal);
Color FR_grab_gradient(Color c1, Color c2, float banding, float zero_to_one);


// Misc project-specific nonsense
//
int  detect_windows();
void good_ending();

void draw_message(int msg, int timing);
void draw_action_tooltip();
void draw_journal_selection();
void draw_journal_descriptions(const char *title, const char *desc, float x, float y, float alpha);
void poke_to_death(int who);
void apply_damage(int who);
void display_signal(int type);
void buffer_sfx(int sfx_slot, int ticks);


void update_and_render();
void render_frame(int mode);    // Standard rendering

void init_game_variables();

int  get_free_actor();
int  get_population(int team);
int  get_initial();

int  check_floats(float one, float two, float range);                // Checks if two floats are within [range]
int  check_collision(int who, int target, int radius, int z_adjust); // Checks a single target for distance overlap





// Old Framework stuff here
int sorted[MAX_ACTORS][2];

void FR_merge_actors();
void FR_prep_for_sort();
void FR_quicksort(int low, int high);
void FR_swap_int(int n1, int n2, int index);
int  FR_2d_dist(int x1, int y1, int x2, int y2);
int  quick_rand(int range);
float scale(float value, float source_min, float source_max, float scaled_min, float scaled_max);
float norm_f(float source, float min, float max);
float FR_2d_angle_360_f(float x1, float y1, float x2, float y2);
Vector2 rotate_point_2d(float point_x, float point_y, float around_x, float around_y, float angle);
float degrees_to_radians(float degrees);
bool valid_actor(int who);
// End nonsense


// Wrapping nonsense
void blit(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h);
void blit_v(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h);
void blit_h(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h);
void push_rect(Rectangle *rect, float x, float y, float w, float h);



// Important actor tracking vars
//
int puppet        = -1; // Actor being controlled by the player
int railcar       = -1;
int shark         = -1;
int fish_line     = -1;
int octopus       = -1;
int octo_arms[6]  = { -1, -1, -1, -1, -1, -1 };
int thrusters[2]  = { -1, -1 };

int population[2] = { 0, 0 };


char custom_text[80];
float screenSize[2];

double rad_conv   = (PI / 180);

int calculate     = 0;  // Defers calculations for so many frames
int tutorial_seen = 0;
int game_over     = 0;  // Triggers end of game (0 = game active. 1 = summary. 2 = high score)
int total_actors  = 0;  // Debugging var


int select        = 0;  // Current player's menu selection
int accept        = 0;  // Current player's prompt selection
int yes_no        = 0;  // shows prompt when > 0



int high_score    = 666;
unsigned char high_init[4] = { 71, 68, 82, 0 };

int slow_time     = 0;            // > 0 if time is slowed by player
int slow_frame    = 0;            // Current number of updates skipped by slowdown

int box_tex_x     = 0;            // For anchoring happy texture at game over summary
int box_tex_y     = 0;            //
int box_update    = 0;            //

int water_tex_x   = 0;            // For anchoring happy texture at game over summary
int water_tex_y   = 0;            //
int water_update  = 0;            //

int clock_min     = 0;            // Countdown readout
int clock_sec     = 0;            //
int clock_sub     = 0;            //

int score         = 0;            // Your score
int score_diff    = 0;            // Score differential. Positive values add, negative subtract.
int score_shake   = 0;            // Number of frames to "shake" score display. Used for negative hits.
int score_ticks   = 0;            // User for score tracking

int quake_ticks    = 1800;        // Frames before next quake
int quake_base     = 3600;        // Base ticks
int quake_spread   = 1800;        // Randomness to quakes
int quake_duration = 0;           // Quake frames left to animation

float game_time   = 0;            // Elapsed game time
int frame_ticks   = 0;            // Used for end game animations
int show_signal   = -1;           // Shows ball or strike indicator on screen
int swung         = 0;            // > 0 if current pitch has been swung at
int swing_active  = 0;            // Are we swinging the bat?
int swing_angle   = 0;            // What angle did we commit to?
int sfx_buffer[16][2];            // Allows buffering of sounds (up to 16, by clock ticks)

int game_mode     = 0; // 0 = title.    1 = Tutorial.     2 = game.    3 = Game Over.     4 = Credits?
float anims[16]   = { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 };
float t_angle[4]  = { 0.0, 0.0, 0.0, 0.0 };
float t_offset[4] = { 0.0, 90.0, 180.0, 270.0 };


Camera2D camera      = { 0 };
Vector2 cam_velocity = { 0, 0 };

Vector2 mouse        = { 0, 0 };
Vector2 mouse_cam    = { 0, 0 };


Texture2D tex_title;
Texture2D tex_emoji;
Texture2D tex_fire;
Texture2D tex_brush;
Texture2D tex_rays;
Texture2D tex_knob;
Texture2D tex_knob_plate;
Texture2D tex_fish;
Texture2D tex_shark;
Texture2D tex_octopus;
Texture2D tex_evil_fish;
Texture2D tex_kelp;
Texture2D tex_heart;
Texture2D tex_heart_break;
Texture2D tex_rainbow;
Texture2D tex_damage;
Texture2D tex_railcar;
Texture2D tex_censored;
Texture2D tex_journal;
Texture2D tex_line;
Texture2D tex_arm;
Texture2D tex_stars;
Texture2D tex_water;
Texture2D tex_waves;
Texture2D tex_clouds;
Texture2D tex_pages;
Texture2D tex_page_outline;

Texture2D tex_32x;
Texture2D tex_64x;
Texture2D box_tex;

Sound sfx[MAX_SFX];

Font font1;                   // Bubble font
Font font3;                   // 3x5 font

RenderTexture2D target;       // For full-screen shader handling


// Shader crap here (plz move this into something sane FFS)
//
Shader scroll;
float scroll_vars[4] = { 0.0, 0.0, 0.0, 0.0 }; // Two sets of x/y offsets
int off_xLoc   = 0;
int off_yLoc   = 0;

Shader wave;
float s_vars[6] = {  4.0,  0.0,  4.0, 0.0,  2.0,  0.0 };  // Brush sine wave
float l_vars[6] = {  3.0,  0.0,  4.0, 0.0, 18.0,  0.0 };  // Squid Death sine wave
float k_vars[6] = {  6.0, 00.0, 32.0, 0.0,  1.0,  0.0 };  // Kelp sine wave
float h_vars[6] = { 10.0, 00.0, 64.0, 0.0,  2.0,  0.0 };  // Hook sine wave
float f_vars[6] = { 10.0, 10.0,  4.0, 4.0, 18.0, 18.0 };  // Fire sine wave
int secondsLoc = 0;
int freqXLoc   = 0;
int freqYLoc   = 0;
int ampXLoc    = 0;
int ampYLoc    = 0;
int speedXLoc  = 0;
int speedYLoc  = 0;

int loc_time     = 0;
int loc_strength = 0;
float seconds    = 0.0f;
float strength   = 0.0005f;




// Game-specific flags. Can wipe between projects
//
struct flags_struct
{
 int puffed;                  // Keeps puffing sfx from repeating
 int win;                     // > 0 if player has won the game
 int message;                 // > 0 if an important message is being displayed on-screen
 int message_timing;          // Tracks message timing and fade out
 int window;                  // > 0 if player is sitting over a window
 int inked;                   // Tracks ink levels
 int page_drop;               // Tracks fish page drop (prevents dupes)
 int kills;                   // Tracks fish kills (for dropping page)
 int regen;                   // Tracks regenerative timing
 int shot_ready;              // Tracks shot readiness (for player)
 int d_frames;                // > 0 if player has been damaged
 int selected;                // > 0 if player has selected a page to swap in
 int non_consentual;          // > 0 if player is getting groped by horny squid
 int hiding;                  // > 0 if player is hiding in a window
 int hiding_dir;              // 0 for hiding, 1 for coming out of hiding
 int health;                  // Player health          (0-5)
 int pages[5];                // Journal pages collected
 int charge;                  // Player's "puff" charge (0-360)
 int charge_skip;             // Ghetto way to skip a frame per charge
 int last_clock;              // Used to check for score multiplier accretion
 int last_sec;                // Used to check for bullet sfx timing
 float ending;                // Tracks ending sequence
 float score_multiplier;      // You can figure this out
 float spawn;                 // Tracks randomly spawning rays
};

flags_struct flags;





struct anim_struct
{
 int frame_x[MAX_FRAMES];     // x cell of frame inside sprite sheet (cell, not pixel)
 int frame_y[MAX_FRAMES];     // y cell of frame inside sprite sheet
 int timing[MAX_FRAMES];      // timing in game "ticks" to get to next frame
 int total_frames;            // maximum number of frames in this sequence
};

anim_struct anim[MAX_ANIMATIONS];





struct actor_struct
{
 Texture2D cel;         // Pointer to source texture
 Vector3 pos;           // Position
 Vector3 offset;        // Destination (only used to move enemies around)
 Vector3 dest;          // Destination (only used to move enemies around)
 Vector3 path;          // (OPTIONAL) Path of travel (x/y/z)
 Color color;           // Color tint (WHITE by default)

 float blend;           // Blend strength (0-1)    < only applies if not solid >
 float angle;           // Angle of rotation (0-360)
 float v_angle;         // (OPTIONAL) Angle of movement (0-360)
 float v_speed;         // (OPTIONAL) Velocity of movement (tied to v_angle)
 float v_roll;          // (OPTIONAL) != 0 if actor rolls while in flight

 float scale;           // Actor scale (populated during projection)
 float roll;            // != 0 if actor's sprite rolls in place
 float y_shift;         // Dirty hack to physically shift a sprite on y axis by ? pixels (pre-projection)

 float quake;           // > 0 if actor is rolling from damage
 float speed;           // Actor's base speed (0.0 to 0.20) which is added to their movement each turn
 float last_angle;      // Last angle actor had before rotation command (for squid)

 int team;              // 1 = Friendly    2 = Enemy    6 = Inert substances
 int shadow;            // > -1 if an actor is their shadow
 int _size_w;           // Dimensions of the cel frame
 int _size_h;           // Dimensions of the cel frame
 int flip;              // Force horizontal mirroring
 int anim_set;          // Animation set to reference
 int anim_step;         // Which step in the anim sequence we're at
 int anim_timing;       // Current step timing for animation
 int anim_loop;         // # of times to loop animation. 0 if only played once
 int mode;              // Used for misc tracking (per-project)
 int state;             // 0 = inactive. 1-12 = doing stuff
 int effect;            // 0 = none.
 int owner;             // Actor that owns this (used to define simple relationships)
 int timer;             // Internal timer for animation purposes, or whatever you need
 int stamina;           // Walking and being attacked drain stamina. When <= 0 the actor dies or fades out
 int cel_x;             // X cel within sprite sheet
 int cel_y;             // Y cel within sprite sheet
 int locked_to;         // Actor this player was triggered by (so ammo doesn't hit the actor firing it!)
 int following;         // Actor this actor is following
 int extra;             // Extra data point for use wherever (lazy!)
 int event;             // > 0 if actor will trigger an event when their commitment has ended
 int inert;             // > 0 if actor should not check collisions. Count down.

 float scale_ramp;      // Maximum value scale additive will ramp to
 float scale_mod;       // Modifies scale variable, when rendering sprite. This is a factor.
 float scale_up;        // Speed of scale ramping
 float scale_down;      // Speed of scale ramping

 int updates;           // Number of movement updates per -tick (default is 1)
 int moved_up;          // > 0 if actor has moved up recently
 int moved_down;        // > 0 if actor has moved down recently
 int moved_wait;        // > 0 if actor needs to wait before heading to next way-point

 int d_pad[4];          // Janky virtual gamepad (refine later)
 int buttons[4];        //

 int shader;            // > 0 if a shader is in use with this actor
 float s_vars[10];      // Storage space for shader vars. These will vary according to the shader in use

 bool decal;            // Indicates actor is a floor decal, and will be drawn before normal actors
 bool flicker;          // Tracks actor flicker (used by effects)
 bool mirror;           // TRUE if actor is mirrored on X-axis
 bool gravity;          // TRUE if gravity affects Y coordinate
 bool projected;        // TRUE is actor is passed through projection stage before drawing
 bool enabled;          // TRUE if this actor is active
 bool visible;          // TRUE if this actor will be drawn to screen
 bool accessory;        // TRUE if actor will be rendered with a package object
                        // and should not be drawn or interacted with otherwise
};

actor_struct actors[MAX_ACTORS];





// I got tired of making everything global. Fuck me.
//
struct hi_struct
{
 int selected;                // Character currently selected (0-2 valid)
 unsigned char initials[3];   // Stores characters entered by user
 int blink;                   // True if we can display blinking chars
 int blink_timer;             // Timer to track above variable
};

hi_struct hi_score;




bool SKIP_INTRO = 0;          // TRUE if we want to skip the title screen and tutorial
float debug[10] = { 0.0, 0.0, 0.0, 0.0, 0.0,   0.0, 0.0, 0.0, 0.0, 0.0 };




const char *state_string[] = {
 /* 00 */ ".",
 /* 01 */ ".",
 /* 02 */ ".",
 /* 03 */ ".",
 /* 04 */ ".",
 /* 05 */ ".",
 /* 06 */ ".",
 /* 07 */ ".",
 /* 08 */ ".",
 /* 09 */ "."
};






int main(void)
{
 int next = 0;
 int exit = 0;


    // Init OpenGL instance. If MIDI tweaking is in use, add 300 pixels
    // at bottom of window for rendering knobs and pads
    //
    SetConfigFlags(FLAG_VSYNC_HINT);

    #ifdef USE_RTMIDI
    InitWindow(SCREEN_W, SCREEN_H + 300, "CC-007 - PUFFER TRAIN");
    #else
    InitWindow(SCREEN_W, SCREEN_H, "CC-007 - PUFFER TRAIN");
    #endif

    InitAudioDevice();

    // Only use this is vsync isn't available
    //
    // SetTargetFPS(60);

    HideCursor();



    /// FEATURE SETS ///

    #ifdef USE_RTMIDI
    init_midi();
    init_arturia_profile();
    //load_knobs();

    rescale_midi_device_rel(midi.knobs[12],  0.0, (float)SCREEN_H * 6, 4.0);
    #endif


    screenSize[0] = (float)GetScreenWidth();
    screenSize[1] = (float)GetScreenHeight();


    //target = LoadRenderTexture(SCREEN_W, SCREEN_H);

    // Load textures
    //
    tex_emoji        = LoadTexture("gfx/tex_emoji.png");
    tex_title        = LoadTexture("gfx/tex_title.png");
    tex_fire         = LoadTexture("gfx/tex_fire.png");
    tex_brush        = LoadTexture("gfx/tex_brush.png");
    tex_rays         = LoadTexture("gfx/tex_rays.png");
    tex_fish         = LoadTexture("gfx/tex_fish.png");
    tex_shark        = LoadTexture("gfx/tex_shark.png");
    tex_octopus      = LoadTexture("gfx/tex_octopus.png");
    tex_evil_fish    = LoadTexture("gfx/tex_evil_fish.png");
    tex_kelp         = LoadTexture("gfx/tex_kelp.png");
    tex_heart        = LoadTexture("gfx/tex_heart.png");
    tex_heart_break  = LoadTexture("gfx/tex_heart_break.png");
    tex_rainbow      = LoadTexture("gfx/tex_rainbow.png");
    tex_damage       = LoadTexture("gfx/tex_damage.png");
    tex_railcar      = LoadTexture("gfx/tex_railcar.png");
    tex_censored     = LoadTexture("gfx/tex_censored.png");
    tex_line         = LoadTexture("gfx/tex_line.png");
    tex_arm          = LoadTexture("gfx/tex_arm.png");
    tex_stars        = LoadTexture("gfx/tex_stars.png");
    tex_water        = LoadTexture("gfx/tex_water.png");
    tex_waves        = LoadTexture("gfx/tex_waves.png");
    tex_clouds       = LoadTexture("gfx/tex_clouds.png");
    tex_journal      = LoadTexture("gfx/tex_journal.png");
    tex_pages        = LoadTexture("gfx/tex_pages.png");
    tex_page_outline = LoadTexture("gfx/tex_page_outline.png");

    tex_32x          = LoadTexture("gfx/tex_32x.png");
    tex_64x          = LoadTexture("gfx/tex_64x.png");
    box_tex          = LoadTexture("gfx/box_tex.png");

    tex_knob         = LoadTexture("gfx/tex_knob.png");
    tex_knob_plate   = LoadTexture("gfx/tex_knob_plate.png");


    // Custom font loading
    //
    font1 = LoadFont("gfx/16x_bubble.png");
    font3 = LoadFont("gfx/3x_square.png");


    // Wave Shader crap
    //
    wave       = LoadShader(0, "SHADERS/wave.fs");
    secondsLoc = GetShaderLocation(wave, "secondes");
    freqXLoc   = GetShaderLocation(wave, "freqX");
    freqYLoc   = GetShaderLocation(wave, "freqY");
    ampXLoc    = GetShaderLocation(wave, "ampX");
    ampYLoc    = GetShaderLocation(wave, "ampY");
    speedXLoc  = GetShaderLocation(wave, "speedX");
    speedYLoc  = GetShaderLocation(wave, "speedY");

    SetShaderValue(wave,   GetShaderLocation(wave, "size"), &screenSize, SHADER_UNIFORM_VEC2);


    // Scroll shader crap
    //
    scroll   = LoadShader(0, "SHADERS/scroll_xy.fs");
    off_xLoc = GetShaderLocation(scroll, "offset_x");
    off_yLoc = GetShaderLocation(scroll, "offset_y");


    // Load sound effects
    //
    sfx[1]  = LoadSound("sfx/001.wav"); // Duck into train
    sfx[2]  = LoadSound("sfx/002.wav"); // OK GUI beep
    sfx[3]  = LoadSound("sfx/003.wav"); // Wrong/NOPE GUI beep / Squid croaking
    sfx[5]  = LoadSound("sfx/005.wav"); // Fire radiance
    sfx[6]  = LoadSound("sfx/006.wav"); // Non-consensual lovin
    sfx[7]  = LoadSound("sfx/007.wav"); // Impacting boss eye
    sfx[9]  = LoadSound("sfx/009.wav"); // Puffing up

    sfx[11] = LoadSound("sfx/011.wav"); // Killing a normal enemy
    sfx[12] = LoadSound("sfx/012.wav"); // Player taking a hit
    sfx[17] = LoadSound("sfx/017.wav"); // Thruster fire
    sfx[18] = LoadSound("sfx/018.wav"); // Thruster fire
    sfx[19] = LoadSound("sfx/019.wav"); // Hitting boss tail
    sfx[20] = LoadSound("sfx/020.wav"); // Winrar
    sfx[21] = LoadSound("sfx/021.wav"); // Collecting journal page


    // Set sound effect attributes
    //
    SetSoundVolume(sfx[1], 0.20);
    SetSoundPitch(sfx[1],  1.00);

    SetSoundVolume(sfx[2], 0.20);
    SetSoundPitch(sfx[2],  1.00);

    SetSoundVolume(sfx[3], 0.20);
    SetSoundPitch(sfx[3],  1.00);

    SetSoundVolume(sfx[5], 0.20);
    SetSoundPitch(sfx[5],  1.00);

    SetSoundVolume(sfx[6], 0.20);
    SetSoundPitch(sfx[6],  1.00);

    SetSoundVolume(sfx[7], 0.20);
    SetSoundPitch(sfx[7],  1.00);

    SetSoundVolume(sfx[9], 0.20);
    SetSoundPitch(sfx[9],  1.00);

    SetSoundVolume(sfx[11], 0.20);
    SetSoundPitch(sfx[11],  0.50);

    SetSoundVolume(sfx[12], 0.20);
    SetSoundPitch(sfx[12],  1.00);

    SetSoundVolume(sfx[17], 0.35);
    SetSoundPitch(sfx[17],  0.50);

    SetSoundVolume(sfx[18], 0.35);
    SetSoundPitch(sfx[18],  0.40);

    SetSoundVolume(sfx[19], 0.20);
    SetSoundPitch(sfx[19],  1.00);

    SetSoundVolume(sfx[20], 0.20);
    SetSoundPitch(sfx[20],  0.50);

    SetSoundVolume(sfx[21], 0.20);
    SetSoundPitch(sfx[21],  1.00);



    // We will call this routine to clean up on program exit
    //
    atexit(cleanup);


    // We will land here after a successful game loop
    //
    restart:


    init_game_variables();




    if(SKIP_INTRO) { goto skip_jank; }



    /// Title block loop ---------------------------------------------------------------------------------------
    //
    do {
        anims[0] = 1.00;
        update_and_render();

        anims[15] += 0.05;
        if(anims[15] >= 360.00) { anims[15] -= 360.00; }

        if(IsKeyDown(KEY_Z)) { next = 1; }
        if(next && (!IsKeyDown(KEY_Z))) { PlaySound(sfx[2]); exit = 1; }

       } while (!exit);



    // Fade Title out
    //
    do {
        anims[0] -= 0.025;
        update_and_render();
       } while (anims[0] > 0.00);



    /// Tutorial Loop ------------------------------------------------------------------------------------------
    //
    if(!tutorial_seen) {
        // Tutorial Display loop (only on first game of each session)
        //
        next      = 0;
        exit      = 0;
        game_mode = 1;

        do {
            update_and_render();

            if(IsKeyDown(KEY_Z)) { next = 1; }
            if(next && (!IsKeyDown(KEY_Z))) { PlaySound(sfx[2]); exit = 1; }

           } while (!exit);


        // Fade Title out
        //
        do {
            anims[1] -= 0.04;
            update_and_render();
           } while (anims[1] > 0.00);

        tutorial_seen = 1;
                       }



    skip_jank:

    /// Main Game Loop -----------------------------------------------------------------------------------------
    //
    next      = 0;
    exit      = 0;
    game_mode = 2;




    while (!game_over) {

         #ifdef USE_RTMIDI
         if(IsKeyDown(KEY_F7)) {
             do { update_and_render(); } while(IsKeyDown(KEY_F7));
             load_knobs();
                               }
         #endif


        if(flags.win) { good_ending(); }

        update_and_render();
                       }


    // End game summary and high score
    //
    end_game(flags.win);

    goto restart;

    return(0);
}





// This routine is automatically called at program exit
//
void cleanup()
{

 #ifdef USE_RTMIDI
 save_knobs();
 #endif


 CloseWindow();                // Close window and OpenGL context

 return;
}






// Performs logic update and calls rendering stuff
//
void update_and_render()
{
 total_actors   = 0;


 if(WindowShouldClose()) { exit(0); }


 #ifdef USE_RTMIDI
 poll_midi();
 #endif

 #ifdef USE_TEXTBOX
 check_textbox();
 #endif

 check_shaders();
 check_animations();
 check_actors();


 if(!game_over && game_mode > 1) {
     check_sfx_buffer();
     check_input();
     check_spawns();
     check_score();

     if(!slow_time || (slow_time && slow_frame > 3)) {
         check_time();
         slow_frame = 0;
                                                     }
     else { slow_frame++; }
                                 }

 render_frame(game_mode);

 return;
}







void render_frame(int mode)
{
 Vector2 dest = { 0 };

 Color brush_start = BLANK;
 Color brush_end   = BLANK;

 Color sky_top     = (Color){ 110, 180, 234, 255 };
 Color sky_bottom  = (Color){   8, 105, 214, 255 };

 float quake_scale = 0.0;
 float charge_str  = 0.65;
 float a_start     = 1.0;
 float a_end       = 1.0;



 if(quake_duration) {
     quake_scale = 30.0 * ((float)quake_duration / 180.00);
     camera.offset.x += GetRandomValue(-quake_scale, quake_scale);
     camera.offset.y += GetRandomValue(-quake_scale, quake_scale);
     quake_duration--;
                    }
 else {
     camera.offset.x = (float)SCREEN_W / 2.0f;
     camera.offset.y = (float)SCREEN_H / 2.0f;
      }


 // Camera should follow player, but will let go once we're close to the edge
 //
 camera.target.x = actors[puppet].pos.x;
 if(camera.target.x < (SCREEN_W * 0.5)) { camera.target.x = (SCREEN_W * 0.5); }
 if(camera.target.x > (SCREEN_W * 4.5)) { camera.target.x = (SCREEN_W * 4.5); }


 //flags.ending = midi.knobs[12].value;
 if(flags.ending > 0.0) {
     camera.target.y = (SCREEN_H / 2) - flags.ending;
                        }
 else { camera.target.y = (SCREEN_H / 2); }


 BeginDrawing();


 // I've painted myself into a bit of a corner.
 // The 2D stuff doesn't want to work with negative coords,
 // and the top of the screen is zero. So if we try to go
 // above that, nothing seems to work.
 //
 // Jank solution is to draw everything at 0 coords *before*
 // turning on the camera, and let everything else fall away...
 //
 if(flags.ending > 0.0) {
     // Railcar and thrusters will follow us "up"
     // We also need to kill the shader over the railcar
     //
     if(flags.ending > 900)  { actors[railcar].effect = 0; }
     if(flags.ending < 5000) { actors[railcar].quake  = 1.00; }
     if(flags.ending > 5000) { actors[railcar].roll   = 0.05; }

     actors[railcar].pos.z = flags.ending;


     actors[thrusters[0]].pos.z = flags.ending - 64;
     actors[thrusters[1]].pos.z = flags.ending - 64;

     // We will draw a gradient texture that fades away as we rise,
     // revealing the stars drawn underneath it
     //
     DrawTextureEx(tex_stars, (Vector2){0.0, 0.0}, 0.0, 2.0, WHITE);

     a_start = scale(flags.ending, 0.0, 5400.0, 1.0, 0.0);
     a_end   = scale(flags.ending, 900.0, 5400.0, 1.0, 0.0);
     DrawRectangleGradientV(0, 0, SCREEN_W, flags.ending + 1, Fade(WHITE, a_start), Fade(sky_top, a_end));
                        }



 BeginMode2D(camera);


 // Draw "Sky"
 //
 DrawRectangleGradientV(0, 0, SCREEN_W * 5, SCREEN_H - 330, sky_top, sky_bottom);


 // Draw "Ground"
 //
 brush_start = ColorFromHSV(212.0, 0.96, 0.85);
 brush_end   = ColorFromHSV(160.0, 0.45, 0.26);

 DrawRectangleGradientV(0, SCREEN_H - 330, SCREEN_W * 5, 330, brush_start, brush_end);


 // Sort actors
 //
 FR_prep_for_sort();
 FR_quicksort(0,(MAX_ACTORS-1));
 FR_merge_actors();



 // Having drawn all the necessary stuff, handle mode-specific overlays
 //
 switch(game_mode) {
     case 0: // Title screen
             draw_title_hud("P R E S S   [Z]   T O   S T A R T");
             draw_title();
             break;

     case 1: // Introduction / Tutorial
             draw_tutorial();
             break;

     case 2: // In-game
             if(show_signal != -1) { draw_signal(show_signal); }
             if(flags.ending >= 5300) { draw_title_hud("P R E S S   [Z]   T O   E N D"); }
             break;

     case 3: // Game over / Summary (LOSE)
             draw_summary(0);
             break;

     case 4: // Game over / Summary (WIN)
             draw_summary(1);
             break;
                   }


 // Draw recharge (do it with cam active for lazy calculations lol)
 //
 if(flags.selected == 4) { flags.charge = 360; }

 if(flags.charge < 360 && !flags.non_consentual) {
     dest.x = actors[puppet].pos.x;
     dest.y = actors[puppet].pos.y - actors[puppet].pos.z - 60;

     if(!IsKeyDown(KEY_X)) { charge_str *= 0.5; }

     DrawRing(dest, 70.0, 90.0, 0.0+180, flags.charge+180, 100, Fade(SKILL_PINK, charge_str));
     DrawRing(dest, 70.0, 90.0, flags.charge+180, flags.charge+190, 100, Fade(WHITE, charge_str + 0.15));
                                                 }

 if(flags.window && !flags.hiding && !flags.non_consentual) { draw_action_tooltip(); }

 if(flags.message) { draw_message(flags.message, flags.message_timing); }

 if(!game_over && game_mode > 1 && flags.hiding && !flags.win) { draw_journal_selection(); }



 EndMode2D();


 if(flags.ending > 0) {
     // Also draw a water layer and cloud layer as we pass by
     //
     DrawTextureEx(tex_waves, (Vector2){-64 + (sin(anims[15] * (PI / 180.0)) * 64.0),    -330 + flags.ending}, 0.0, 2.0, WHITE);
     DrawTextureEx(tex_waves, (Vector2){-64 + (sin((anims[15] + 90) * (PI / 180.0)) * 64.0),  -330 + 10 + flags.ending}, 0.0, 2.5, WHITE);
     DrawTextureEx(tex_waves, (Vector2){-64 + (sin((anims[15] + 270)* (PI / 180.0)) * 64.0), -330 + 24 + flags.ending}, 0.0, 3.0, WHITE);


     DrawTextureEx(tex_clouds, (Vector2){0.0, -3100 + flags.ending}, 0.0, 2.0, WHITE);
                      }


 if(!game_over && game_mode > 1 && !flags.ending) { draw_hud(); }

 #ifdef USE_RTMIDI
 draw_midi_knobs();
 #endif


 EndDrawing();

 return;
}





void draw_high_score()
{

 return;
}




// NOTE: Checks player input for activity
//
void check_input()
{
 float player_speed = 5.0;


 if(flags.health <= 0) { game_over = 1; return; }


 // Hide player behind censored bar
 //
 if(flags.non_consentual > 60) { actors[puppet].effect = 99; }
 else                          { actors[puppet].effect = 0;  }

 if(flags.non_consentual == 60) { kill_squid(); }

 if(flags.message_timing > 0) { flags.message_timing--; }
 if(flags.message_timing == 0) { flags.message = 0; }


 // Update page status if enough ink has been spilled (lol)
 //
 if(flags.inked == 6 && flags.pages[2] != 1) {
     flags.pages[2] = 1;
     flags.message = 1;
     flags.message_timing = 300;
                                             }


 // Player cannot act while censored or d_framed
 //
 if(flags.non_consentual > 0) {
     flags.non_consentual--;
     return;
                              }

 if(flags.d_frames > 0) { return; }



 // Side-to-side motion
 //
 if(!flags.hiding) {

 if(IsKeyDown(KEY_LEFT) || IsKeyDown(KEY_A)) {
     actors[puppet].flip = 0;
     if(actors[puppet].pos.x > 100) { actors[puppet].pos.x -= player_speed; }
                                             }

 if(IsKeyDown(KEY_RIGHT) || IsKeyDown(KEY_D)) {
     actors[puppet].flip = 1;
     if(actors[puppet].pos.x < ((SCREEN_W * 5) - 100)) { actors[puppet].pos.x += player_speed; }
                                              }

 // Up-down motion
 //
 if(IsKeyDown(KEY_UP) || IsKeyDown(KEY_W)) {
     if(actors[puppet].pos.z < 700) { actors[puppet].pos.z += player_speed; }
                                           }

 if(IsKeyDown(KEY_DOWN) || IsKeyDown(KEY_S)) {
     if(actors[puppet].pos.z > 40)  { actors[puppet].pos.z -= player_speed; }
                                             }


 // Pressing (and holding) Z shoots radiance if you've got it equipped
 //
 if(flags.shot_ready > 0) { flags.shot_ready--; }
 else {
     if(flags.selected == 4) {
         if(IsKeyDown(KEY_X)) {
             if(actors[puppet].flip) { // Right shot
                 spawn_radiance(actors[puppet].pos.x + 70, actors[puppet].pos.y + 1, actors[puppet].pos.z + 32, 1);
                                     }
             else { // Left shot
                 spawn_radiance(actors[puppet].pos.x - 70, actors[puppet].pos.y + 1, actors[puppet].pos.z + 32, 0);
                  }
             flags.shot_ready = 15;
                              }
                             }
      }

 // Pressing (and holding) X puffs you us while energy is charged
 //
 if(!flags.d_frames) {
     if(IsKeyDown(KEY_X) && flags.selected != 4) {
         if(!flags.puffed) { PlaySound(sfx[9]); }
         flags.puffed = 1;
         actors[puppet].cel_x = 0;
         flags.charge -= 3;
         if(flags.charge <= 0) {
             flags.charge = 0;
                               }
                                                 }

     else {
         actors[puppet].cel_x = 1;
         flags.charge_skip ^= 1;
         flags.puffed = 0;
         if(!flags.charge_skip) { flags.charge++; }
         if(flags.charge > 360) { flags.charge = 360; }
          }
                     }
                   }


 flags.window = detect_windows();


 if(flags.hiding) {
     if(!flags.hiding_dir) { if(flags.hiding < 30) { flags.hiding++; } }
     else                  { flags.hiding--;                           }

     if((IsKeyDown(KEY_UP)    || IsKeyDown(KEY_W)) && flags.pages[0]) { flags.selected = 1; }
     if((IsKeyDown(KEY_LEFT)  || IsKeyDown(KEY_A)) && flags.pages[1]) { flags.selected = 2; }
     if((IsKeyDown(KEY_DOWN)  || IsKeyDown(KEY_S)) && flags.pages[2]) { flags.selected = 3; }
     if((IsKeyDown(KEY_RIGHT) || IsKeyDown(KEY_D)) && flags.pages[3]) { flags.selected = 4; }
                  }

 //
 if(flags.window && !flags.hiding) {
     if(IsKeyDown(KEY_Z)) {
         if(flags.pages[4]) { PlaySound(sfx[1]); flags.hiding = 1; flags.hiding_dir = 0; flags.win = 1; }
         else               { PlaySound(sfx[1]); flags.hiding = 1; flags.hiding_dir = 0; }
                          }
                                   }

 if(flags.hiding) {
     actors[puppet].blend = scale(flags.hiding, 0, 30, 1.00, 0.00);
     actors[puppet].scale = scale(flags.hiding, 0, 30, 1.00, 0.75);

     if(flags.hiding == 30 && IsKeyDown(KEY_Z)) {
         flags.hiding_dir = 1;
                                                }
                  }


 /// DIRTY HACKS
 /// Make player sprite bob (it's a fucking fish, aye?)
 ///
 actors[puppet].pos.z += (sin(anims[2] * (PI / 180.0)) * 0.25);


 switch(flags.selected) {
     case 0: // Nothing selected
             actors[puppet].color = WHITE;
             break;

     case 1: // Regen selected
             actors[puppet].color = GREEN;
             break;

     case 2: // Steel Jaws selected
             actors[puppet].color = CHILL_CYAN;
             break;

     case 3: // Assault Barbs selected
             if(flags.pages[2] == 1) { actors[puppet].color = PURPLE; }
             else                    { actors[puppet].color = WHITE;  }
             break;

     case 4: // Radiant Light selected
             actors[puppet].color = YELLOW;
             break;
                        }

 return;
}




void check_spawns()
{
 int i      = 0;
 int k      = 0;
 int _r     = 0;
 int dist   = 0;
 int dist_m = 0;
 int dist_t = 0;


 // Kill off all spawns during ending, and prevent new ones
 //
 if(flags.ending > 0.0) {
     if(flags.ending < 10.0) {
         for(k=0; k<MAX_ACTORS; k++) {
             if(actors[k].enabled && actors[k].team == 2) { actors[k].state = 4; }
                                     }
                             }
     return;
                        }


 // Fake-ass crepuscular ray spawn
 //
 flags.spawn--;
 if(flags.spawn <= 0) {
     spawn_ray((float)GetRandomValue(-50, ((SCREEN_W * 5) - 50)), 0.0, 0.0);
     flags.spawn = 6 + GetRandomValue(0, 8); // 10/30
                      }


 // Evil fish spawn
 //
 if(actors[puppet].pos.x > 1600 && actors[puppet].pos.x < 6400) {
     _r = quick_rand(200);
     if(_r <= 1) {
         if(!_r) { spawn_evil_fish(800,  actors[puppet].pos.y + 1, 150.0 + GetRandomValue(0, 400), 0); }
         else    { spawn_evil_fish(7200, actors[puppet].pos.y + 1, 150.0 + GetRandomValue(0, 400), 1); }
                 }
                                                                }


 // Slightly less evil hook spawn
 //
 _r = quick_rand(200);
 if(_r <= 1) {
     if(!_r) { spawn_hook(1600 + quick_rand(1600), actors[puppet].pos.y + 1, 600 + quick_rand(500), 0); }
     else    { spawn_hook(4800 + quick_rand(1600), actors[puppet].pos.y + 1, 600 + quick_rand(500), 0); }
             }


 // Very goddamn evil horny squid spawn
 //
 _r = quick_rand(400);
 if(_r <= 1) {
     spawn_squid(1600 + quick_rand(4800), actors[puppet].pos.y + 1, 600 + quick_rand(500), quick_rand(360));
             }


 if(flags.d_frames) {
     flags.d_frames--;
     actors[puppet].cel_x = 2;
     actors[puppet].angle = flags.d_frames / 2;
                    }



 if(flags.non_consentual > 0) { return; }
 if(flags.hiding) { return; }


 for(i=0; i<MAX_ACTORS; i++) {

     if(actors[i].team == 8) { // Journal page
         dist = check_collision(i, puppet, 50, 0);
         if(dist && actors[i].following == -1) {
             if(actors[i].event >= 0 && actors[i].event < 5) {
                 if(actors[i].event == 4) { flags.message = 2; flags.message_timing = 400; }
                 flags.pages[actors[i].event] = 1;
                                                             }
             if(actors[i].locked_to != -1) { actors[actors[i].locked_to].state = 4; }
             actors[i].team  = 6;
             actors[i].state = 4;
             PlaySound(sfx[21]);
                                               }
         continue;
                             }

     // Check collisions for normal enemies (i.e. not bosses)
     //
     if(i != puppet && i != shark && i != fish_line &&
        i != octo_arms[0] && i != octo_arms[1] && i != octo_arms[2] &&
        i != octo_arms[3] && i != octo_arms[4] && i != octo_arms[5]) {
         if(actors[i].enabled && actors[i].team == 2 && !actors[i].inert) {
             dist = check_collision(i, puppet, 50, 0);

             if(actors[i].state == 21) { // Hook
                 if(dist) {
                     if(flags.selected != 2) { apply_damage(i); }
                     else { kill_hook(i); }
                          }
                 continue;
                                       }

             else {
                 // Apply damage if not puffed up, or enemy is immune
                 //
                 if(dist && !actors[i].inert) {
                     if(!actors[i].extra) { apply_damage(i); }
                     else {
                         if(IsKeyDown(KEY_X) && flags.charge > 0) { poke_to_death(i); }
                         else { apply_damage(i); }
                          }
                                              }
                  }
                                                                          }
                                                                     }
                             }




 if(fish_line != -1) {
     dist = check_collision(fish_line, puppet, 50, 0);
     if(actors[fish_line].team == 2) {
         if(dist) {
             if(flags.selected != 2) { apply_damage(i); }
             else {
                 kill_hook(fish_line);
                 for(k=0; k<MAX_ACTORS; k++) {
                     if(actors[k].following == fish_line) { actors[k].following = -1; }
                                             }
                  }
                  }
                                     }
                     }

 // Now check for shark collisions (I'd normally use an array, but maybe this is more readable for ppl?)
 //
 if(shark != -1) {
     if(actors[shark].cel_x == 1) { // Dashing state. Player can be damaged by mouth, or damage tail
         if(!actors[shark].flip) {
             dist_m = FR_2d_dist(actors[puppet].pos.x, actors[puppet].pos.y - 64 - actors[puppet].pos.z,
                                 actors[shark].pos.x - 210, actors[shark].pos.y - actors[shark].pos.z - 20);
             dist_t = FR_2d_dist(actors[puppet].pos.x, actors[puppet].pos.y - 64 - actors[puppet].pos.z,
                                 actors[shark].pos.x + 240, actors[shark].pos.y - actors[shark].pos.z + 64);
                                 }
         else {
             dist_m = FR_2d_dist(actors[puppet].pos.x, actors[puppet].pos.y - 64 - actors[puppet].pos.z,
                                 actors[shark].pos.x + 210, actors[shark].pos.y - actors[shark].pos.z - 20);
             dist_t = FR_2d_dist(actors[puppet].pos.x, actors[puppet].pos.y - 64 - actors[puppet].pos.z,
                                 actors[shark].pos.x - 240, actors[shark].pos.y - actors[shark].pos.z + 64);
              }
                                  }

     if(actors[shark].cel_x == 0) { // Pausing state. Player can damage tail
         if(!actors[shark].flip) {
             dist_m = 9999; // Can't hit
             dist_t = FR_2d_dist(actors[puppet].pos.x, actors[puppet].pos.y - 64 - actors[puppet].pos.z,
                                 actors[shark].pos.x + 150, actors[shark].pos.y - actors[shark].pos.z + 120);
                                 }
         else {
             dist_m = 9999; // Can't hit
             dist_t = FR_2d_dist(actors[puppet].pos.x, actors[puppet].pos.y - 64 - actors[puppet].pos.z,
                                 actors[shark].pos.x - 150, actors[shark].pos.y - actors[shark].pos.z + 120);
              }

                                  }

     if(dist_m < 75 && actors[shark].state != 33) { apply_damage(puppet); }
     if(dist_t < 75 && flags.charge > 0 && flags.selected == 3 &&
        flags.pages[2] == 1 &&
        IsKeyDown(KEY_X) && actors[shark].state != 33) {
            PlaySound(sfx[19]);
            spawn_damage(actors[shark].pos.x + 100 + quick_rand(100), actors[shark].pos.y + 1, actors[shark].pos.z, 1);

            actors[shark].stamina--;
            actors[shark].state = 33;
            actors[shark].cel_x = 2;
            actors[shark].timer = 120;
                                                       }
                 }

 // Check Octopus arm collision
 //
 for(i=0; i<6; i++) {
     if(octo_arms[i] != -1) {
         k = octo_arms[i];
         dist = FR_2d_dist(actors[puppet].pos.x, actors[puppet].pos.y - 64 - actors[puppet].pos.z,
                           actors[k].pos.x + 440, actors[k].pos.y - actors[k].pos.z - 60);

         if(dist < 50) { apply_damage(puppet); }
                            }
                    }

 return;
}





void check_sfx_buffer()
{
 int i = 0;


 for(i=0; i<16; i++) {
     if(sfx_buffer[i][0] != -1) {
         sfx_buffer[i][1]--;

         if(sfx_buffer[i][1] <= 0) {
             PlaySound(sfx[sfx_buffer[i][0]]);
             sfx_buffer[i][0] = -1;
             sfx_buffer[i][1] = 0;
                                   }

                                }
                     }

 return;
}










// Adjusts score over time
//
void check_score()
{
 int factor = 1;
 int total  = 0;


 // Score multiplier, if time is < 2 minutes, will recover by 2x every
 // minute. It will decrease by 2x every time you fire your Dragon
 // It will decrease by 1x every time you drop a shield
 //
 if(clock_min > 0) {
     if(clock_min != flags.last_clock) { flags.score_multiplier += 2.0; flags.last_clock = clock_min; }
     if(flags.score_multiplier > 10.0) { flags.score_multiplier = 10.0; }
                   }


 // Score shakes when bad things happen
 //
 if(score_shake > 0) { score_shake--; }


 // Roll differential into score over time. The larger the difference,
 // the faster we will update the score. Eventually roll this into a log formula.
 //
 if(score_diff != 0) {

     total = abs(score_diff);
     if(total > 20)   { factor = 2;  }
     if(total > 50)   { factor = 4;  }
     if(total > 100)  { factor = 8;  }
     if(total > 250)  { factor = 16; }
     if(total > 500)  { factor = 32; }
     if(total > 999)  { factor = 64; }
     if(total > 1999) { factor = 128; }
     if(total > 3999) { factor = 256; }
     if(total > 6999) { factor = 512; }

     if(score_diff > 0) { score += factor; score_diff -= factor; }
     if(score_diff < 0) { score -= factor; score_diff += factor; }
                     }

 // Bounds check
 //
 if(score < 0)        { score = 0;        }
 if(score > 99999999) { score = 99999999; }


 return;
}






void check_shaders()
{

 // Used by *quite* a lot of shaders
 //
 seconds += GetFrameTime();


 // Update wave shader
 //
 SetShaderValue(wave, secondsLoc, &seconds, SHADER_UNIFORM_FLOAT);


 // Update Cut-out scroll shader
 //
 scroll_vars[0] += 0.0003;
 scroll_vars[1] += 0.0005;

 scroll_vars[2] -= 0.0004;
 scroll_vars[3] += 0.00025;

 return;
}






void check_animations()
{
 int i = 0;
 int SET = 0;

 /// Specific to this project
 ///
 if(flags.ending) {
     float rescale = scale(flags.ending, 0, 5400, 2.0, 10.0);
     flags.ending += rescale;
                  }


 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled && actors[i].anim_set) {
         SET = actors[i].anim_set;

         actors[i].anim_timing++;

         // Check for frame advance
         //
         if(actors[i].anim_timing >= anim[SET].timing[actors[i].anim_step]) {
             actors[i].anim_step++;
             actors[i].anim_timing = 0;

             // Check for end, or looping
             //
             if(actors[i].anim_step >= anim[SET].total_frames) {
                 if(actors[i].anim_loop) {
                     actors[i].anim_step = 0;
                     actors[i].anim_timing = 0;
                     actors[i].anim_loop--;
                                         }

                 else { actors[i].anim_set = 0; }
                                                               }
                                                                            }

         // If anim is still set, update frame
         // ** SHOULD PLACE IN ROUTINE SO WE CAN SANITY CHECK ANIM_STEP VALUE **
         //
         if(actors[i].anim_set) {
             SET = actors[i].anim_set;
             actors[i].cel_x = anim[SET].frame_x[actors[i].anim_step];
             actors[i].cel_y = anim[SET].frame_y[actors[i].anim_step];
                                }
                                                 }
                             }


 // Floating object animation
 //
 anims[2] += 1.0;
 if(anims[2] > 360.00) { anims[2] -= 360.00; }


 // Flashing mini-map indicator animation
 //
 anims[3] += 0.03;
 if(anims[3] > 1.00) { anims[3] -= 1.00; }


 // UI selection pulsing animation
 //
 anims[4] += 4.0;
 if(anims[4] > 360.00) { anims[4] -= 360.00; }


 // Quake damage pulsing (fed into sin())
 //
 anims[5] += 8.0;
 if(anims[5] > 360.00) { anims[5] -= 360.00; }


 // Holding position shuffle (slow, lazy sine)
 //
 anims[6] += 0.01;
 if(anims[6] > 360.00) { anims[6] -= 360.00; }


 // Flashing Title indicator (50% to 100% opacity)
 //
 anims[7] += 0.04;
 if(anims[7] > 360.00) { anims[7] -= 360.00; }


 // Cape waving animation (fed into sin())
 //
 anims[8] += 8.0;
 if(anims[8] > 360.00) { anims[8] -= 360.00; }


 // Signal fade
 //
 anims[9] -= 0.01;
 if(anims[9] < 0.00) { anims[9] = 0.00; }


 // Title emoji rotation (360 degrees X 4)
 //
 anims[14] += 2.0;
 if(anims[14] >= 1440.00) { anims[14] -= 1440.00; }


 // Title emoji animation
 //
 anims[15] += 2.0;
 if(anims[15] >= 360.00) { anims[15] -= 360.00; }


 return;
}





// NOTE: Keeps track of game time, and parses the ticks left
//       into human readable format
//
void check_time()
{
 div_t d;
 div_t e;

 if(game_mode != 2) { return; }


 d = div(game_time, 3600);

 clock_min = d.quot;

 e = div(game_time - (d.quot * 3600), 60);
 clock_sec = e.quot;
 clock_sub = e.rem;


 // Quake ticks
 //
 quake_ticks--;

 if(quake_ticks <= 0) {
     quake_ticks = quake_base + GetRandomValue(0, quake_spread);
                      }


 if(flags.selected == 1 && !flags.hiding) {
     if(flags.health < 5) {
         flags.regen++;
         if(flags.regen >= 300) { flags.health++; flags.regen = 0; }
                          }
                                          }
 return;
}






// Kills off dead actors, spawns new ones over time
//
void check_actors()
{
 int i           = 0;
 int k           = 0;

 float dist      = 0.0;
 float speed     = 0.0;
 float _ang      = 0.0;


 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled) {

         if(actors[i].shadow != -1) {
             k = actors[i].shadow;
             actors[k].pos.x = actors[i].pos.x;
             actors[k].pos.y = actors[i].pos.y - 1;
             actors[k].pos.z = actors[i].pos.z - 6;
                                    }

         // Actor is following another
         //
         if(actors[i].following != -1) {
             k = actors[i].following;
             actors[i].pos.x = actors[k].pos.x;
             actors[i].pos.y = actors[k].pos.y - 1;
             actors[i].pos.z = actors[k].pos.z - 32;
                                       }

         // Actor is quaking
         //
         if(actors[i].quake > 0.000) {
             actors[i].angle = sin(anims[5]) * actors[i].quake;
             actors[i].quake -= 0.15;
             if(actors[i].quake <= 0.000) {
                 actors[i].angle = 0.0;
                 actors[i].quake = 0.0;
                                          }
                                     }

         // Actor is sprite rolling, angle rolling, or flickering
         //
         if(actors[i].roll > 0.001 || actors[i].roll < -0.001) { actors[i].angle += actors[i].roll; }
         if(actors[i].v_roll > 0.001 || actors[i].v_roll < -0.001) { actors[i].v_angle += actors[i].v_roll; }

         // Actor's "warhead" is inert
         //
         if(actors[i].inert > 0) { actors[i].inert--; }



         switch(actors[i].state) {
             case 0: // Inactive
                     break;

             case 2: // Waits for stamina to run out. Then dies
                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         actors[i].flicker = 0;
                         actors[i].blend -= 0.02;
                         if(actors[i].blend <= 0.0) { kill_actor(i); }
                                                }
                     break;

             case 3: /// Angle + Speed movement (ON Z AXIS ONLY). + FADE OVER TIME
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.z += cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) { kill_actor(i); }

                     actors[i].blend -= 0.005;
                     if(actors[i].blend <= 0.00 ) { kill_actor(i); }
                     break;

             case 4: // Fading out, then expiring
                     actors[i].blend -= 0.03;
                     if(actors[i].blend <= 0.00 ) { kill_actor(i); }
                     break;

             case 5: // Shot: Angle + speed movement
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.y -= cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         actors[i].inert = 1;
                         actors[i].blend -= 0.06;
                         if(actors[i].blend <= 0.0) { kill_actor(i); break; }
                                                }

                     if(actors[i].inert > 0) { break; }

                     // Check for collision with fish / squid
                     //
                     for(k=0; k<MAX_ACTORS; k++) {
                         if(actors[k].enabled && actors[k].team == 2 &&
                            actors[k].mode) {
                                dist = FR_2d_dist(actors[i].pos.x, actors[i].pos.y - actors[i].pos.z - ((actors[i]._size_h * actors[i].scale) / 2.0),
                                                  actors[k].pos.x, actors[k].pos.y - actors[k].pos.z - ((actors[k]._size_h * actors[k].scale) / 2.0));
                                if(dist < 50) {
                                    actors[i].inert   = 1;
                                    actors[i].stamina = 0;
                                    actors[k].state   = 10;
                                    actors[k].team    = 6;
                                              }
                                            }

                         // Check for Octopus eye collision (weird that I have this here)
                         //
                         if(k == octopus) {
                                dist = FR_2d_dist(actors[i].pos.x, actors[i].pos.y - actors[i].pos.z - ((actors[i]._size_h * actors[i].scale) / 2.0),
                                                  actors[k].pos.x + 150, actors[k].pos.y - actors[k].pos.z - 390);
                                if(dist < 50) {
                                    actors[i].inert   = 1;
                                    actors[i].stamina = 0;
                                    actors[k].quake   = 5.00;
                                    if(actors[k].stamina > 0) { actors[k].stamina--; }
                                        PlaySound(sfx[7]);
                                        spawn_damage(actors[k].pos.x + 100 + quick_rand(100), actors[k].pos.y + 1, actors[k].pos.z + 390, 1);
                                              }

                                          }
                                                 }
                     break;

             case 6: // Slow elliptical orbit
                     speed = actors[i].v_speed;

                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * speed;
                     actors[i].pos.y -= cos(actors[i].v_angle * (PI / 180.0)) * (speed / 8.0);
                     break;

             case 7: /// Angle + Speed movement (ON Z AXIS ONLY).
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.z += cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) { kill_actor(i); }
                     break;

             case 8: // Rays (Path movement)
                     actors[i].pos.x += actors[i].path.x;
                     actors[i].pos.y += actors[i].path.y;
                     actors[i].pos.z += actors[i].path.z;

                     actors[i].blend += 0.01;
                     if(actors[i].blend >= 1.50) { actors[i].state = 9; }
                     break;

             case 9: // Rays (Path movement)
                     actors[i].pos.x += actors[i].path.x;
                     actors[i].pos.y += actors[i].path.y;
                     actors[i].pos.z += actors[i].path.z;

                     actors[i].blend -= 0.01;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

            case 10: // Damage marker / Dead enemy (scales up, fades out)
                     actors[i].scale += 0.020;
                     actors[i].blend -= 0.015;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

            case 11: // Evil fish (path movement + sine Z)
                     /// ** DO NOT REUSE THIS BEHAVIOR **
                     actors[i].pos.x += actors[i].path.x;
                     actors[i].pos.z += (sin(anims[2] * (PI / 180.0)) * 2.0);

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) { actors[i].state = 4; actors[i].team = 6; }
                     break;

            case 16: // Squid pause and rotate to direction
                     if(actors[i].owner != -1) { break; }

                     if(abs(actors[i].angle - actors[i].last_angle) >= 5.0) {
                         actors[i].angle += 5.00;
                         if(actors[i].angle > 360.00) { actors[i].angle -= 360.00; }
                         if(actors[i].angle < 0.00)   { actors[i].angle += 360.00; }
                                                                            }
                     else {
                         actors[i].timer++;
                         if(actors[i].timer > 30) {
                             actors[i].v_speed = 20.00;
                             actors[i].v_angle = actors[i].angle + 225;
                             actors[i].state   = 17;
                             actors[i].timer   = 0;
                                                  }
                          }
                     actors[i].cel_x = 2;

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) { actors[i].state = 4; actors[i].team = 6; }
                     break;

            case 17: // Squid rush
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.z += cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     if(actors[i].pos.z < 0.0) { actors[i].pos.z = 0.0; }
                     actors[i].v_speed *= 0.94;

                     actors[i].cel_x = 3;
                     if(actors[i].v_speed <= 0.1 || actors[i].owner != -1) {
                         actors[i].v_speed = 0.0;
                         actors[i].timer++;
                         if(actors[i].timer > 10) {
                             actors[i].last_angle = quick_rand(360);
                             actors[i].state   = 16;
                             actors[i].timer   = 0;
                                                  }
                                                                           }
                     actors[i].stamina--; // Don't die mid-rush (that would look janky)
                     break;

            case 18: // Squid / shark / Octopus death sequence (rise up, fade out)
                     actors[i].pos.z += 0.75;

                     actors[i].blend -= 0.0025;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

            case 19: // Censored bar
                     spawn_ink_blot(actors[i].pos.x, actors[i].pos.y-1, actors[i].pos.z);
                     spawn_ink_blot(actors[i].pos.x, actors[i].pos.y-1, actors[i].pos.z);
                     spawn_ink_blot(actors[i].pos.x, actors[i].pos.y-1, actors[i].pos.z);

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0)    { actors[i].state = 4; }
                     if(flags.non_consentual < 60) { actors[i].state = 4; }
                     break;

            case 20: // Hook and line - Dropping down
                     actors[i].pos.x += actors[i].path.x;
                     actors[i].pos.z += actors[i].path.z;

                     actors[i].blend += 0.01;
                     if(actors[i].blend >= 1.00) { actors[i].state = 21; }
                     break;

            case 21: // Hook and line - Slow elliptical orbit
                     /// ** DO NOT REUSE THIS BEHAVIOR **
                     speed = actors[i].v_speed;

                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * speed;
                     actors[i].pos.z -= cos(actors[i].v_angle * (PI / 180.0)) * (speed / 4.0);

                     if(actors[i].stamina != INFINITE) {
                         actors[i].stamina--;
                         if(actors[i].stamina <= 0) { kill_hook(i); }
                                                       }
                     break;

            case 22: // Hook and line - Rising up and fading away
                     actors[i].pos.x += actors[i].path.x;
                     actors[i].pos.z += actors[i].path.z;

                     actors[i].blend -= 0.01;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;

            case 30: // Shark idle/waiting on player in range
                     actors[i].cel_x = 0;
                     if(actors[i].timer > 0) { actors[i].timer--; break; }

                     dist = FR_2d_dist(actors[puppet].pos.x, actors[puppet].pos.y - actors[puppet].pos.z, actors[shark].pos.x, actors[shark].pos.y - actors[shark].pos.z);
                     if(dist < 800)  { actors[i].timer = 10; actors[i].state = 32; }

                     // Prevent player from kiting the boss
                     //
                     if(dist > 1400 || actors[i].pos.x < 1800) { actors[i].pos.x = 7600; actors[i].pos.z = 300; }
                     break;

            case 31: // Shark charging
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.z += cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     if(actors[i].pos.z < 0.0) { actors[i].pos.z = 0.0; }
                     actors[i].v_speed *= 0.96;

                     actors[i].cel_x = 1;
                     if(actors[i].v_speed <= 0.5) {
                         actors[i].v_speed = 0.0;
                         actors[i].timer++;
                         if(actors[i].timer > 10) {
                             actors[i].last_angle = quick_rand(360);
                             actors[i].state   = 30;
                             actors[i].timer   = 10 + quick_rand(15);
                                                  }
                                                  }
                     break;

            case 32: // Shark picking new direction
                     if(actors[i].timer > 0) {
                         actors[i].timer--;
                         if(actors[i].pos.x < actors[puppet].pos.x) { actors[i].flip = 1; }
                         else                                       { actors[i].flip = 0; }

                         if(actors[i].timer <= 0) {
                             _ang = FR_2d_angle_360_f(actors[shark].pos.x, actors[shark].pos.y - actors[shark].pos.z, actors[puppet].pos.x, actors[puppet].pos.y - actors[puppet].pos.z);
                             actors[i].v_angle = _ang;
                             actors[i].v_speed = 30.0;
                                                  }
                                             }
                     else { actors[i].state = 31; }
                     break;

            case 33: // Shark got bopped (this state only accessible by hit detection routine)
                     actors[i].cel_x = 2;
                     if(actors[i].timer > 0) { actors[i].timer--; }
                     else { actors[i].cel_x = 0; actors[i].state = 30; }

                     if(actors[i].stamina <= 0) {
                         actors[i].team   = 6;
                         actors[i].cel_x  = 3;
                         actors[i].effect = 7;
                         actors[i].state  = 18;
                         shark = -1;
                         spawn_journal_page(actors[i].pos.x, actors[i].pos.y + 1, actors[i].pos.z, 3, 1);
                                                }
                     break;

            case 40: // Boss Tentacle - lazy vertical elliptical orbit
                     speed = 4.00;
                     actors[i].v_angle += 1.00;

                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * (speed / 10.0);
                     actors[i].pos.z -= cos(actors[i].v_angle * (PI / 180.0)) * speed;

                     k = quick_rand(320);
                     if(k <= 1) {
                         actors[i].v_speed = 8.00;
                         actors[i].state = 41;
                                }
                     break;

            case 41: // Boss Tentacle - Drawing back for a strike
                     actors[i].pos.x -= sin(90.00 * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].v_speed *= 0.94;

                     if(actors[i].v_speed < 0.01) {
                         actors[i].v_speed = 55.00;
                         actors[i].state = 42;
                                                  }
                     break;

            case 42: // Boss Tentacle - Lashing out
                     actors[i].pos.x += sin(90.00 * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].v_speed *= 0.94;

                     if(actors[i].v_speed < 0.01) { actors[i].state = 43; }
                     break;

            case 43: // Boss Tentacle - retracting
                     actors[i].pos.x -= 16.0;
                     if(actors[i].pos.x < -120) { actors[i].state = 40; }
                     break;

            case 44: // Boss Tentacle - Main body - Lazy vertical elliptical orbit
                     speed = 0.5;
                     actors[i].v_angle += 1.00;

                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * (speed / 10.0);
                     actors[i].pos.z -= cos(actors[i].v_angle * (PI / 180.0)) * speed;

                     if(actors[i].stamina <= 0) {
                         octopus          = -1;
                         actors[i].team   = 6;
                         actors[i].effect = 7;
                         actors[i].state  = 18;
                         spawn_journal_page(actors[i].pos.x + 600, actors[i].pos.y + 1, 300, 4, 1);

                         for(k=0; k<6; k++) {
                             if(octo_arms[k] != -1) {
                                 actors[octo_arms[k]].team   = 6;
                                 actors[octo_arms[k]].effect = 7;
                                 actors[octo_arms[k]].state  = 45;
                                 octo_arms[k]     = -1;
                                                    }
                                            }
                                                }
                     break;

            case 45: // Octopus arm death sequence (fade out, drift up, retract)
                     actors[i].pos.z += 0.75;
                     actors[i].pos.x -= 16.0;
                     actors[i].blend -= 0.0025;
                     if(actors[i].blend <= 0.00) { kill_actor(i); }
                     break;


                                 }
                           }
                             }

 return;
}












void kill_actor(int slot)
{

 // Basic Sanity Check
 //
 if(slot < 0 || slot >= MAX_ACTORS) { printf("ERROR: Invalid slot in kill command. Slot = %d", slot); return; }

 int i = 0;

 actors[slot].enabled     = 0;
 actors[slot].visible     = 1;
 actors[slot].projected   = 0;
 actors[slot].mirror      = 0;
 actors[slot].team        = 0;
 actors[slot].decal       = 0;
 actors[slot].shader      = 0;
 actors[slot].shadow      = -1;
 actors[slot].accessory   = 0;
 actors[slot].y_shift     = 0;
 actors[slot].gravity     = 0;
 actors[slot].flicker     = 0;
 actors[slot].anim_set    = 0;
 actors[slot].anim_step   = 0;
 actors[slot].anim_timing = 0;
 actors[slot].anim_loop   = 0;
 actors[slot].effect      = 0;
 actors[slot].state       = 0;
 actors[slot].mode        = 0;
 actors[slot].flip        = 0;
 actors[slot].timer       = 0;
 actors[slot]._size_w     = 16; // Default value
 actors[slot]._size_h     = 16; // Default value
 actors[slot].inert       = 0;
 actors[slot].extra       = 0;
 actors[slot].event       = 0;
 actors[slot].timer       = 0;
 actors[slot].cel_x       = 0;
 actors[slot].cel_y       = 0;
 actors[slot].following   = -1;
 actors[slot].owner       = -1;
 actors[slot].locked_to   = -1;
 actors[slot].scale       = 1.0f;
 actors[slot].v_angle     = 0.0f;
 actors[slot].v_roll      = 0.0f;
 actors[slot].v_speed     = 0.0f;
 actors[slot].blend       = 1.0f;
 actors[slot].angle       = 0.0f;
 actors[slot].roll        = 0.0f;
 actors[slot].quake       = 0.0f;
 actors[slot].angle       = 0.0f;
 actors[slot].last_angle  = 0.0f;
 actors[slot].speed       = 1.0f; // Default value
 actors[slot].stamina     = 1000;

 actors[slot].scale_ramp  = 0.0;
 actors[slot].scale_mod   = 1.0;
 actors[slot].scale_up    = 0.0;
 actors[slot].scale_down  = 0.0;

 actors[slot].updates     = 1;
 actors[slot].moved_up    = 0;
 actors[slot].moved_down  = 0;
 actors[slot].moved_wait  = 0;

 for(i=0; i<4; i++) { actors[slot].d_pad[i] = 0; actors[slot].buttons[i] = 0; }

 actors[slot].shader      = 0;
 for(i=0; i<10; i++) { actors[slot].s_vars[i] = 0.0; }

 actors[slot].path.x      = 0;
 actors[slot].path.y      = 0;
 actors[slot].path.z      = 0;

 actors[slot].pos.x       = 0;
 actors[slot].pos.y       = 0;
 actors[slot].pos.z       = 0;

 actors[slot].dest.x      = 0;
 actors[slot].dest.y      = 0;
 actors[slot].dest.z      = 0;

 actors[slot].offset.x    = 0;
 actors[slot].offset.y    = 0;
 actors[slot].offset.z    = 0;

 actors[slot].cel         = tex_32x;
 actors[slot].color       = WHITE;
 return;
}






// Spawns a new actor. Types are 0-x for default skin
//
int spawn_actor(int type, float x, float y, float z, int cell_x, float path_x, float path_y, float path_z)
{
 int slot = get_free_actor();

 // Basic Sanity Check
 //
 if(slot < 0 || slot >= MAX_ACTORS) { return(-1); }

 actors[slot].mode      = 0;
 actors[slot].visible   = 1;
 actors[slot].effect    = 0;
 actors[slot].projected = 1;
 actors[slot].blend     = 1.0f;
 actors[slot].angle     = 0.0f;
 actors[slot].timer     = 0;
 actors[slot].stamina   = GetRandomValue(500, 1200); // was 350, 500
 actors[slot].v_angle   = 0.0;
 actors[slot].locked_to = -1;

 actors[slot].pos.x     = x;
 actors[slot].pos.y     = y;
 actors[slot].pos.z     = z;

 actors[slot].path.x    = path_x;
 actors[slot].path.y    = path_y;
 actors[slot].path.z    = path_z;

 actors[slot].cel       = tex_32x; // default value
 actors[slot].cel_x     = cell_x;
 actors[slot].cel_y     = 0;

 actors[slot].state     = 0;
 actors[slot].scale     = 1.0;

 actors[slot].enabled = 1;

 return(slot);
}







// Returns a slot to a free actor.
// If something goes wrong, we will clobber actor 0.
// Do something more graceful later
//
int get_free_actor()
{
 int i = 0;

 for(i=1; i<MAX_ACTORS; i++) {
     if(!actors[i].enabled) { return(i); }
                             }

 return(0);
}





// NOTE: Used to initially populate important stuff that'll never change between sessions
//
void spawn_permanent_actors()
{

 // Create player
 //
 puppet = spawn_player(4000, 935, 104);
 if(puppet == -1) { printf("Fatal error. Couldn't spawn player. Baborting."); exit(0); }

 spawn_weeds();
 spawn_kelp_patches();

 railcar = spawn_railcar(4000, 800, 0);

 return;
}




void spawn_weeds()
{
 int i             = 0;
 int k             = 0;
 int loops         = 0;
 Vector2 dest      = { 0 };
 Color col         = BLANK;
 float scale       = 0.0;
 float off_x       = 0.0;

 float start_x[24] = { -100.0, 0.0, -250.0, -175.0, -47.0, -145.0, -100.0, 0.0, -250.0, -175.0, -47.0, -145.0,
                       -32.0, -96.0, -200.0, -128.0, 0.0, -83.0,  -44.0, -218.0, -165.0, -22.0, -90.0, -128.0 };

 Color brush_start = (Color){ 000, 128, 164, 255 };
 Color brush_end   = (Color){ 022, 255, 149, 255 };

 brush_start = ColorFromHSV(210.0, 1.00, 0.80);
 brush_end   = ColorFromHSV(64.0, 0.87, 0.85);


 for(i=0; i<24; i++) {
     loops = 16 - (i / 2); // try six if not enough
     for(k=0; k<loops; k++) {
         col = FR_grab_gradient(brush_start, brush_end, 0.0, (float)i * 0.054);
         scale = 0.5 + (0.15 * i);

         off_x = (float)k * (tex_brush.width * scale);
         dest.x = start_x[i] + off_x;
         dest.y = SCREEN_H - 305.0 + ((21.70 * i) * (0.50 + (0.02 * i)));

         spawn_brush(dest.x, dest.y, col, scale);
                            }
                     }

 return;
}




void draw_actor(int slot)
{
 // Basic Sanity Check
 //
 if(slot < 0 || slot >= MAX_ACTORS) { return; }

 if(!actors[slot].enabled) { return; }
 if(!actors[slot].visible) { return; }

 float x_flip    = 1.0;
 float alpha     = 1.0;

 Vector2 origin  = { (actors[slot]._size_w / 2) * actors[slot].scale, (actors[slot]._size_h / 2) * actors[slot].scale };

 total_actors++;

 // Flip sprite horizontally if path of travel is negative on x axis
 //
 if(actors[slot].flip) { x_flip = -1.0; /*s_flip = - 4;*/ }

 Rectangle source  = { (actors[slot]._size_w * actors[slot].cel_x), (actors[slot]._size_h * actors[slot].cel_y), actors[slot]._size_w * x_flip, actors[slot]._size_h };


 /// Setting the origin influences these values
 /// Note that we don't need to center the destination on the X axis
 ///                       vv vv vv vv
 Rectangle dest     = { actors[slot].pos.x, actors[slot].pos.y - ((actors[slot]._size_h * actors[slot].scale) / 2) - actors[slot].pos.z + (actors[slot].y_shift * actors[slot].scale), (actors[slot]._size_w * actors[slot].scale), (actors[slot]._size_h * actors[slot].scale) };

 //dest.y -= actors[slot].pos.z;


 // Handle flickering effect (refer to [ALPHA] instead of actors[].blend, from here out)
 //
 if(actors[slot].flicker) {
     alpha = 0.25 + (float)quick_rand(500) / 1000.0;
     alpha *= actors[slot].blend;
                          }
 else { alpha = actors[slot].blend; }


 if(actors[slot].mirror) { source.width *= -1; }


 /// OPTIMIZATION TARGET FOR NEXT RELEASE
 ///
 switch(actors[slot].effect) {
     case 1: // Normal blit + wave shader (FIRE SINE)
             SetShaderValue(wave,  freqXLoc, &f_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &f_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &f_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &f_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &f_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &f_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
                 DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
             EndShaderMode();
             break;

     case 2: // Custom code for brush (BRUSH SINE);
             SetShaderValue(wave,  freqXLoc, &s_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &s_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &s_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &s_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &s_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &s_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
                 DrawTextureEx(actors[slot].cel, (Vector2){actors[slot].pos.x,   (actors[slot].pos.y - (32.0 * actors[slot].scale))}, 0.0, actors[slot].scale, Fade(actors[slot].color, alpha));
             EndShaderMode();
             break;

     case 3: // Additive blur
             BeginBlendMode(BLEND_ADDITIVE);
             blend_helper(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha * 0.10));
             EndBlendMode();
             break;

     case 4: // Kelp blit + wave shader (KELP SINE)
             SetShaderValue(wave,  freqXLoc, &k_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &k_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &k_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &k_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &k_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &k_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
               DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
             EndShaderMode();
             break;

     case 5: // Hook - Normal render + wave-shaded texture going off-screen
             SetShaderValue(wave,  freqXLoc, &h_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &h_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &h_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &h_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &h_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &h_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
             DrawTextureEx(tex_line, (Vector2){actors[slot].pos.x + 244, (actors[slot].pos.y - actors[slot].pos.z - (512.0 * actors[slot].scale))}, actors[slot].angle, actors[slot].scale, Fade(actors[slot].color, alpha));
             EndShaderMode();

             DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
             break;

     case 7: // Squid death blit + wave shader (LINE SINE)
             SetShaderValue(wave,  freqXLoc, &l_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &l_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &l_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &l_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &l_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &l_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
               DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
             EndShaderMode();
             break;

     case 8: // Cut-out shader blit
               DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
               SetShaderValue(scroll,  off_xLoc, &scroll_vars[0], SHADER_UNIFORM_FLOAT);
               SetShaderValue(scroll,  off_yLoc, &scroll_vars[1], SHADER_UNIFORM_FLOAT);
             BeginShaderMode(scroll);
               DrawTexturePro(tex_water, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha * 0.20));
             EndShaderMode();

               SetShaderValue(scroll,  off_xLoc, &scroll_vars[2], SHADER_UNIFORM_FLOAT);
               SetShaderValue(scroll,  off_yLoc, &scroll_vars[3], SHADER_UNIFORM_FLOAT);
             BeginShaderMode(scroll);
               DrawTexturePro(tex_water, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha * 0.20));
             EndShaderMode();
             break;

    case 99: // Do nothing (if visibility is being fucked with)
             break;

    default: // Normal blit
             /// Uncomment if shadows are supported in this project
             //if(actors[slot].shadow && actors[slot].pos.y < 0.2) {
             //    DrawTexturePro(tex_sprites, (Rectangle){32, 0, 16, 16}, dest, origin, actors[slot].angle, Fade(actors[slot].color, actors[slot].blend));
             //                                                    }

             /// Debugging lines ///
             /// DrawLine(0, actors[slot].pos.y, 2000, actors[slot].pos.y, WHITE);
             /// DrawLine(actors[slot].pos.x, 0, actors[slot].pos.x, 2000, WHITE);

             DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, alpha));
             break;
                             }



 return;
}





// NOTE: This is only called by the above routine, when blending, to keep the code from being jank
//
void blend_helper(Texture2D source, Rectangle rect_s, Rectangle rect_d, Vector2 origin, float angle, Color tint)
{
 float drift = 2;

 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x -= drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);


 // Next pass
 //
 drift = 1;

 rect_d.x -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x -= drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 return;
}





// NOTE: This is used to put a soft additive glow on the eyes
//       Can't use the above routine because the call is to EX instead of pro, and I'm fucking lazy
//
void blend_helper_ex(Texture2D source,  Vector2 dest, float angle, float scale, Color tint)
{
 float drift = 3;

 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x -= drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x += drift;
 dest.y -= drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x += drift;
 dest.y += drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x -= drift;
 dest.y += drift;
 DrawTextureEx(source, dest, angle, scale, tint);


 drift = 1;
 dest.x -= drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x += drift;
 dest.y -= drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x += drift;
 dest.y += drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x -= drift;
 dest.y += drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 return;
}





int get_population(int team)
{
 int i = 0;
 int total = 0;

 for(i=1; i<MAX_ACTORS; i++) {
     if(actors[i].enabled) {
         if(actors[i].team == team) { total++; }
                           }
                             }

 return(total);
}






// NOTE: Draws the top/bottom banners for the title screen
//       Should only have minor changes between projects
//
void draw_title_hud(const char *msg)
{
 Vector2 pos      = { 0, 0 };
 Vector2 len      = { 0, 0 };

 EndMode2D();

 len   = MeasureTextEx(font1, msg, font1.baseSize * 2, 1);
 pos.x = (SCREEN_W / 2) - (len.x / 2);
 pos.y = SCREEN_H - 64;

 sprintf(custom_text, msg);
 DrawTextEx(font1, custom_text, pos, font1.baseSize * 2, 1, Fade(WHITE, (1.0 * anims[3])));

 BeginMode2D(camera);

 return;
}




// NOTE: Paints a "press X to Y" message over player position
//
void draw_action_tooltip()
{
 Vector2 len     = { 0 };
 Vector2 anchor  = { actors[puppet].pos.x, actors[puppet].pos.y - actors[puppet].pos.z - 164 };
 float alpha     = 1.0;
 int b_size      = 6;
 int l_size      = 4;


 len = MeasureTextEx(font3, "PRESS       TO HIDE", font3.baseSize * l_size, l_size);
 DrawTextEx(font3, "PRESS       TO HIDE", (Vector2){anchor.x - (len.x / 2) + l_size, anchor.y + l_size}, font3.baseSize * l_size, l_size, Fade(BLACK, 0.75 * alpha));
 DrawTextEx(font3, "PRESS       TO HIDE", (Vector2){anchor.x - (len.x / 2), anchor.y}, font3.baseSize * l_size, l_size, Fade(WHITE, 1.00 * alpha));


 len = MeasureTextEx(font3, "[Z]", font3.baseSize * b_size, b_size);
 DrawTextEx(font3, "[Z]", (Vector2){anchor.x - 15 - (len.x / 2) + b_size, anchor.y - 5 + b_size}, font3.baseSize * b_size, b_size, Fade(BLACK, 0.75 * alpha));
 DrawTextEx(font3, "[Z]", (Vector2){anchor.x - 15 - (len.x / 2), anchor.y - 5}, font3.baseSize * b_size, b_size, Fade(YELLOW, 1.00 * alpha));


 return;
}




// NOTE: Draws an "important message" centered toward the bottom of the screen
//
void draw_message(int msg, int timing)
{
 Vector2 len     = { 0 };
 Vector2 anchor  = { actors[puppet].pos.x, 700.0 };
 float alpha     = 1.0;
 int b_size      = 6;

 if(timing < 60) { alpha = scale(timing, 0.0, 60.0, 0.0, 1.0); }

 switch(msg) {
     case 1: // Page inked
             len = MeasureTextEx(font3, "JOURNAL PAGE REPAIRED!", font3.baseSize * b_size, b_size);
             DrawTextEx(font3, "JOURNAL PAGE REPAIRED!", (Vector2){anchor.x - 15 - (len.x / 2) + b_size, anchor.y - 5 + b_size}, font3.baseSize * b_size, b_size, Fade(BLACK, 0.75 * alpha));
             DrawTextEx(font3, "JOURNAL PAGE REPAIRED!", (Vector2){anchor.x - 15 - (len.x / 2), anchor.y - 5}, font3.baseSize * b_size, b_size, Fade(YELLOW, 1.00 * alpha));
             break;

     case 2: // Launch codes received
             len = MeasureTextEx(font3, "LAUNCH CODES RECOVERED. RETURN TO TRAIN!", font3.baseSize * b_size, b_size);
             DrawTextEx(font3, "LAUNCH CODES RECOVERED. RETURN TO TRAIN!", (Vector2){anchor.x - 15 - (len.x / 2) + b_size, anchor.y - 5 + b_size}, font3.baseSize * b_size, b_size, Fade(BLACK, 0.75 * alpha));
             DrawTextEx(font3, "LAUNCH CODES RECOVERED. RETURN TO TRAIN!", (Vector2){anchor.x - 15 - (len.x / 2), anchor.y - 5}, font3.baseSize * b_size, b_size, Fade(YELLOW, 1.00 * alpha));
             break;
             }

 return;
}




void draw_journal_descriptions(const char *title, const char *desc, float x, float y, float alpha)
{
 Vector2 len     = { 0 };

 len = MeasureTextEx(font3, title, font3.baseSize * 4, 4);

 DrawTextEx(font3, title, (Vector2){x + 4 - (len.x / 2), y + 4 + 220}, font3.baseSize * 4, 4, Fade(BLACK, 0.75 * alpha));
 DrawTextEx(font3, title, (Vector2){x - (len.x / 2), y + 220}, font3.baseSize * 4, 4, Fade(WHITE, 1.00 * alpha));

 len = MeasureTextEx(font3, desc, font3.baseSize * 4, 4);

 y += 32;
 DrawTextEx(font3, desc, (Vector2){x + 4 - (len.x / 2), y + 4 + 220}, font3.baseSize * 4, 4, Fade(BLACK, 0.75 * alpha));
 DrawTextEx(font3, desc, (Vector2){x - (len.x / 2), y + 220}, font3.baseSize * 4, 4, Fade(ORANGE, 1.00 * alpha));

 return;
}




void draw_journal_selection()
{
 float   alpha   = 0.0;
 float   alpha_b = 0.0;
 float   spread  = 120.0;
 Color   col     = BLANK;
 Vector2 p       = { 0 };
 Vector2 r       = { 0 };
 Vector2 q       = { 0 };
 Vector2 origin  = { 0 };
 Vector2 anchor  = { actors[puppet].pos.x, actors[puppet].pos.y - actors[puppet].pos.z - 64 };

 alpha   = scale(flags.hiding, 0.0, 30.0, 0.0, 1.0);
 alpha_b = alpha;

 // Top, Journal page 1 (A)
 //
 p.x = anchor.x;
 p.y = anchor.y - scale(flags.hiding, 0.0, 30.0, 0.0, spread);
 if(flags.selected == 1) { r = p; col = RED; }
 else                    { col = WHITE;      }

 if(!flags.pages[0]) { alpha_b = alpha * 0.25; }
 else                { alpha_b = alpha;        }
 DrawTexturePro(tex_pages, (Rectangle) {0, 0, 128, 128}, (Rectangle) {p.x - 64, p.y - 64, 128, 128}, origin, 0.0, Fade(col, alpha_b));


 // Left, Journal page 2 (B)
 //
 p.x = anchor.x - scale(flags.hiding, 0.0, 30.0, 0.0, spread);
 p.y = anchor.y;
 if(flags.selected == 2) { r = p; col = RED; }
 else                    { col = WHITE;      }

 if(!flags.pages[1]) { alpha_b = alpha * 0.25; }
 else                { alpha_b = alpha;        }
 DrawTexturePro(tex_pages, (Rectangle) {128, 0, 128, 128}, (Rectangle) {p.x - 64, p.y - 64, 128, 128}, origin, 0.0, Fade(col, alpha_b));


 // Bottom, Journal page 3 (C)
 //
 p.x = anchor.x;
 p.y = anchor.y + scale(flags.hiding, 0.0, 30.0, 0.0, spread);
 if(flags.selected == 3) { r = p; col = RED; }
 else                    { col = WHITE;      }

 if(!flags.pages[2]) { alpha_b = alpha * 0.25; }
 else                { alpha_b = alpha;        }
 DrawTexturePro(tex_pages, (Rectangle) {256, 0, 128, 128}, (Rectangle) {p.x - 64, p.y - 64, 128, 128}, origin, 0.0, Fade(col, alpha_b));


 // Right, Journal page 4 (D)
 //
 p.x = anchor.x + scale(flags.hiding, 0.0, 30.0, 0.0, spread);
 p.y = anchor.y;
 if(flags.selected == 4) { r = p; col = RED; }
 else                    { col = WHITE;      }

 if(!flags.pages[3]) { alpha_b = alpha * 0.25; }
 else                { alpha_b = alpha;        }
 DrawTexturePro(tex_pages, (Rectangle) {384, 0, 128, 128}, (Rectangle) {p.x - 64, p.y - 64, 128, 128}, origin, 0.0, Fade(col, alpha_b));



 // Draw flashing highlight around selected page
 //
 if(flags.selected) {
     q.x = r.x - 64 * (1.0 + anims[3]);
     q.y = r.y - 64 * (1.0 + anims[3]);
     DrawTextureEx(tex_page_outline, q, 0.0, (1.0 + anims[3]), RED);

     q.x = r.x - 64 * (0.8 + anims[3]);
     q.y = r.y - 64 * (0.8 + anims[3]);
     DrawTextureEx(tex_page_outline, q, 0.0, (0.8 + anims[3]), RED);
                    }

 switch(flags.selected) {
     case 0: // Nothing
             draw_journal_descriptions("NOTHING SELECTED", "GO OUT AND COLLECT SOME PAGES!", anchor.x, anchor.y, alpha);
             break;
     case 1: // Regen
             draw_journal_descriptions("REGENERATION", "HEALS DAMAGE OVER TIME", anchor.x, anchor.y, alpha);
             break;
     case 2: // Steel Jaws
             draw_journal_descriptions("STEEL JAWS", "ALLOWS CHOMPING THROUGH METAL", anchor.x, anchor.y, alpha);
             break;
     case 3: // Assault Barbs
             if(flags.inked < 6) {
                 draw_journal_descriptions("FADED PAGE", "THE INK HAS FADED OVER THE YEARS", anchor.x, anchor.y, alpha);
                                 }
             else {
                 draw_journal_descriptions("ASSAULT BARBS", "YOUR BARBS CAN DAMAGE BIG ENEMIES", anchor.x, anchor.y, alpha);
                  }
             break;
     case 4: // Radiant Light
             draw_journal_descriptions("RADIANT LIGHT", "REPLACES BARBS WITH RADIANT POWER", anchor.x, anchor.y, alpha);
             break;
                        }

 return;
}





void draw_hud()
{
 int i       = 0;
 float pl_x  = 0.0;
 float flash = 0.0;

 // Health on left side of screen
 //
 for(i=1; i<6; i++) {
     if(flags.health >= i) {
         DrawTextureEx(tex_heart, (Vector2){ -50 + (70 * i), 10 }, 0.0, 2.0, WHITE);
                           }
     else {
         DrawTextureEx(tex_heart_break, (Vector2){ -50 + (70 * i), 10 }, 0.0, 2.0, WHITE);
          }
                    }

 // Collected Journal pages on left side, under health
 //
 for(i=0; i<4; i++) {
     if(flags.pages[i]) {
         DrawTextureEx(tex_journal, (Vector2){ 650 + (70 * i), 10 }, 0.0, 0.5, WHITE);
                        }
     else {
         DrawCircle(670 + (70 * i), 45, 10, Fade(BLACK, 0.5));
          }
                    }


 // Mini-map on right side of screen
 //
 DrawRectangleRounded((Rectangle){ SCREEN_W - 360, 20, 340, 50 }, 0.5, 32, Fade(BLACK, 0.25));
 pl_x = scale(actors[puppet].pos.x, 0, 8000, SCREEN_W - 350, SCREEN_W - 30);
 flash = (float)GetRandomValue(20, 80) / 100.0;
 DrawCircle(pl_x, 45, 10, Fade(WHITE, flash));


 // Draw Control Hints
 //
 DrawTextEx(font3, "ARROW KEYS / WASD - MOVE PLAYER                                                              Z - INTERACT    X - PUFF UP", (Vector2){80+2, SCREEN_H - 18}, font3.baseSize * 3, 3, Fade(BLACK, 0.75));
 DrawTextEx(font3, "ARROW KEYS / WASD - MOVE PLAYER                                                              Z - INTERACT    X - PUFF UP", (Vector2){80, SCREEN_H - 20}, font3.baseSize * 3, 3, Fade(ORANGE, 1.00));

 // Draw Journal page description
 //
 switch(flags.selected) {
     case 0: // Nothing
             draw_journal_descriptions("NOTHING SELECTED", " ", 195.0, -130.0, 1.00);
             break;
     case 1: // Regen
             draw_journal_descriptions("REGENERATION", " ", 195.0, -130.0, 1.00);
             break;
     case 2: // Steel Jaws
             draw_journal_descriptions("STEEL JAWS", " ", 195.0, -130.0, 1.00);
             break;
     case 3: // Assault Barbs
             if(flags.inked < 6) {
                 draw_journal_descriptions("FADED PAGE", " ", 195.0, -130.0, 1.00);
                                 }
             else {
                 draw_journal_descriptions("ASSAULT BARBS", " ", 195.0, -130.0, 1.00);
                  }
             break;
     case 4: // Radiant Light
             draw_journal_descriptions("RADIANT LIGHT", " ", 195.0, -130.0, 1.00);
             break;
                        }

 return;
}





// NOTE: Draws the actual title screen, with animations and whatnot
//
void draw_title()
{
 float alpha      = 0.0;
 Vector2 pos      = { 0 };
 Color col        = BLANK;

 // Draw emoji (nothing special this time. I'm feeling lazy)
 //
 pos.x = 3900 - (tex_title.width / 2);
 SetShaderValue(wave,  freqXLoc, &l_vars[0], SHADER_UNIFORM_FLOAT);
 SetShaderValue(wave,  freqYLoc, &l_vars[1], SHADER_UNIFORM_FLOAT);
 SetShaderValue(wave,  ampXLoc,  &l_vars[2], SHADER_UNIFORM_FLOAT);
 SetShaderValue(wave,  ampYLoc,  &l_vars[3], SHADER_UNIFORM_FLOAT);
 SetShaderValue(wave, speedXLoc, &l_vars[4], SHADER_UNIFORM_FLOAT);
 SetShaderValue(wave, speedYLoc, &l_vars[5], SHADER_UNIFORM_FLOAT);

 BeginShaderMode(wave);
 DrawTextureEx(tex_emoji, (Vector2){pos.x, 100.0}, 0.0, 2.0, Fade(WHITE, 0.50));
 EndShaderMode();



 // This title has a larger camera width. Must center in field, not screen
 //
 pos.x = 4000 - tex_title.width;
 alpha = sin(anims[7]) * 0.25;

 col   = ColorFromHSV(anims[15] - 15.0, 1.00, 1.00);
 DrawTextureEx(tex_title, (Vector2){pos.x + 10, 350.0 + 10}, 0.0, 2.0, Fade(col, (0.25 + (alpha / 2.0))));

 col   = ColorFromHSV(anims[15] - 30.0, 1.00, 1.00);
 DrawTextureEx(tex_title, (Vector2){pos.x + 20, 350.0 + 20}, 0.0, 2.0, Fade(col, (0.15 + (alpha / 2.0))));

 col   = ColorFromHSV(anims[15], 1.00, 1.00);
 DrawTextureEx(tex_title, (Vector2){pos.x, 350.0}, 0.0, 2.0, Fade(col, (0.85 + alpha)));

 return;
}






void draw_signal(int signal)
{
 //float dest_x = SCREEN_W / 2.0;
 //float dest_y = SCREEN_H / 4.0;


 if(signal == 0) {
     ///dest_x -= tex_ball.width;
     ///DrawTextureEx(tex_ball,   (Vector2){dest_x, dest_y}, 0.0, 2.0, Fade(WHITE, anims[9]));
                 }

 if(signal == 1) {
     ///dest_x -= tex_strike.width;
     ///DrawTextureEx(tex_strike, (Vector2){dest_x, dest_y}, 0.0, 2.0, Fade(WHITE, anims[9]));
                 }


 // Dodgy, but we'll kill the signal off in here because I'm lazy
 //
 if(anims[9] <= 0.01) { show_signal = -1; }


 return;
}





// NOTE: Damages the player, and sets up special animations upon impact
//
void apply_damage(int who)
{
 if(who < 0 || who >= MAX_ACTORS) { return; }
 if(flags.d_frames)               { return; }
 if(flags.non_consentual)         { return; }

 ///printf("*** DAMAGED ***\n");

 if(flags.health > 0) { flags.health--; }
 flags.regen = 0;

 int show_marker = 1;

 // Enemy-specific animations and activities
 //
 if(actors[who].state == 21 && who != fish_line) { // Hooks will slide up and away
     actors[who].path.x *= -1;
     actors[who].path.z *= -1;
     actors[who].inert = 1;
     actors[who].state = 22;
                                                 }

 if(actors[who].state >= 16 && actors[who].state <= 17) { // Squid will pile on
     actors[who].owner = puppet;
     show_marker = 0;
     flags.non_consentual = 240;
     spawn_black_bar();
     if(flags.inked < 6) { flags.inked++; }
                                                        }


 // Damage marker over player
 //
 if(show_marker) {
     spawn_damage(actors[puppet].pos.x, actors[puppet].pos.y, actors[puppet].pos.z - 64, 0);
     actors[puppet].cel_x = 2;
     actors[puppet].angle = 30;
     flags.d_frames = 60;
                 }

 PlaySound(sfx[12]);

 return;
}




// NOTE: Damages vulnerable actors (they go inert, float up and disappear)
//
void poke_to_death(int who)
{
 int chance = 0;

 if(who < 0 || who >= MAX_ACTORS) { return; }

 // Evil fish can randomly drop a journal page
 //
 if(!flags.page_drop) {
     if(actors[who].state == 11) {
         flags.kills++;
         if(flags.kills >= 20) {
             chance = 20 + (5 * (flags.kills - 20)); // Chance builds up per kill
             if(quick_rand(100) < chance) {
                 flags.page_drop = 1;
                 spawn_journal_page(actors[who].pos.x, actors[who].pos.y + 1, actors[who].pos.z, 1, 1);
                                          }
                               }
                                 }
                      }

 PlaySound(sfx[11]);

 actors[who].roll    = -4.0 + ((float)GetRandomValue(0, 8000) / 1000.0);
 actors[who].state   = 10;
 actors[who].team    = 6;
 actors[who].inert   = 1;

 return;
}




// Copied-over framework stuff goes here



void FR_merge_actors()
{
 int i = 0;

 // Decals first
 //
 for(i=0; i<MAX_ACTORS; i++) {
     if(sorted[i][1] != -1) {
         if(actors[sorted[i][1]].decal) { draw_actor(sorted[i][1]); }
                            }
                             }


 // Everything else
 //
 for(i=0; i<MAX_ACTORS; i++) {
     if(sorted[i][1] != -1) {
         if(!actors[sorted[i][1]].decal) { draw_actor(sorted[i][1]); }
                            }
                             }

 return;
}







// Add hook to allow for different manners of sorting outside the framework
//
// NOTE: For use with quicksort implementation
//
void FR_prep_for_sort()
{
 int i    = 0;

     for(i=0; i<MAX_ACTORS; i++) {
         sorted[i][0] = -1;
         sorted[i][1] = -1;

         if(actors[i].enabled && !actors[i].accessory) {
             sorted[i][0] = actors[i].pos.y;
             sorted[i][1] = i;
                                                       }
                                 }

 return;
}






// NOTE: OLD CODE IS OLD. Quicksort. Does what it says, says what it does.
//
void FR_quicksort(int low, int high)
{
 int top    = low;
 int bottom = (high - 1);
 int part_index;
 int part_value;

 if (low < high) {

     // Check if elements are sequential
     //
     if(high == (low + 1)) {
         if(sorted[low][0] > sorted[high][0]) { FR_swap_int(high, low, 0); }
                           }

     else {
         // Choose a partition element and swap it with
         // the last value in the array
         //
         part_index = (int)((low + high) / 2);
         part_value = sorted[part_index][0];
         FR_swap_int(high, part_index, 0);

         do {
	         // Inrement the top pointer
             //
	         while((sorted[top][0] <= part_value) && (top <= bottom)) { top++; }

	         // Decrement the bottom pointer
             //
	         while((sorted[bottom][0] > part_value) && (top <= bottom)) { bottom--; }

             // Swap elements if pointers have not met
             //
	         if(top < bottom) { FR_swap_int(top, bottom, 0); }
            } while(top < bottom);

     FR_swap_int(top, high, 0);

     // Recursive calls
     //
     FR_quicksort(low, top - 1);
     FR_quicksort(top + 1, high);
          }

                 }

 return;
}






// NOTE: OLD CODE IS OLD. For use with quicksort implementation
//
void FR_swap_int(int n1, int n2, int index)
{
 int temp;
 int temp2;

 temp  = sorted[n1][0];
 temp2 = sorted[n1][1];

 sorted[n1][0] = sorted[n2][0];
 sorted[n1][1] = sorted[n2][1];

 sorted[n2][0] = temp;
 sorted[n2][1] = temp2;

 return;
}







// OLD CODE IS OLD.
//
int FR_2d_dist(int x1, int y1, int x2, int y2)
{
 double d_x, d_y;
 double distance;

 d_x = x1 - x2;
 d_y = y1 - y2;

 d_x *= d_x;
 d_y *= d_y;

 distance = sqrt((d_x + d_y));

 return((int)distance);
}










void init_game_variables()
{
 int i = 0;

 game_time    = 0.0;
 score        = 0;
 score_diff   = 0;
 score_shake  = 0;
 score_ticks  = 0;
 slow_time    = 0;
 slow_frame   = 0;
 yes_no       = 0;
 select       = 0;
 accept       = 0;
 puppet       = -1;
 show_signal  = -1;
 swing_active = 0;
 swung        = 0;

 clock_min    = 0;
 clock_sec    = 0;
 clock_sub    = 0;

 game_over    = 0;
 box_tex_x    = 0;
 box_tex_y    = 0;
 box_update   = 0;
 frame_ticks  = 0;
 game_mode    = 0;


 for(i=0; i<16; i++) { sfx_buffer[i][0] = -1; sfx_buffer[i][1] = 0; }
 for(i=0; i<16; i++) { anims[i] = 1.0; }

 #ifdef USE_TEXTBOX
 for(i=0; i<MAX_TEXTBOX; i++) {
     textbox[i].pos.x = 0.0;
     textbox[i].pos.y = 0.0;
     textbox[i].pos.width  = 0;
     textbox[i].pos.height = 0;
     textbox[i].scale = 0.0;
     textbox[i].mode = 0;
     textbox[i].ticks = 0;
     textbox[i].viewable_text = 0;
     textbox[i].msg = NULL;
     textbox[i].enabled = 0;
                              }
 #endif


 // Define camera (this will center camera, with focus in middle of screen for rotation)
 // Suitable for use with zooming
 //
 camera.target   = (Vector2){ (float)SCREEN_W / 2.0f, (float)SCREEN_H / 2.0f };
 camera.offset   = (Vector2){ (float)SCREEN_W / 2.0f, (float)SCREEN_H / 2.0f };
 camera.rotation = 0.0f;
 camera.zoom     = 1.0f;



 // Set up actors
 //
 for(i=0; i<MAX_ACTORS; i++) { kill_actor(i); }


 spawn_permanent_actors();


 // Shark and octopus can be killed, and are not considered permanent
 // Same goes for the fishing line with the journal page
 //
 shark = spawn_shark(7600, actors[puppet].pos.y - 1, 300);
 if(shark == -1) { printf("[ ERROR ] : Could not spawn shark. Aborting.\n"); exit(1); }

 fish_line = spawn_hook(1600 + quick_rand(4800), actors[puppet].pos.y - 1, 600 + quick_rand(500), 1);
 if(fish_line == -1) { printf("[ ERROR ] : Could not spawn fishing line. Aborting.\n"); exit(1); }

 octopus = spawn_octopus(40, actors[puppet].pos.y + 1, 0);
 if(octopus == -1) { printf("[ ERROR ] : Could not spawn octopus. Aborting.\n"); exit(1); }
 octo_arms[0] = spawn_octopus_arm(-120, actors[puppet].pos.y - 4, 460);
 octo_arms[1] = spawn_octopus_arm(-120, actors[puppet].pos.y - 3, 460);
 octo_arms[2] = spawn_octopus_arm(-120, actors[puppet].pos.y - 1, 460);
 octo_arms[3] = spawn_octopus_arm(-120, actors[puppet].pos.y - 2, 460);
 octo_arms[4] = spawn_octopus_arm(-120, actors[puppet].pos.y - 5, 460);
 octo_arms[5] = spawn_octopus_arm(-120, actors[puppet].pos.y - 6, 460);



 // Initialize project-specific flags (these can be scrubbed between entries)
 //
 flags.puffed           = 0;
 flags.win              = 0;
 flags.ending           = 0;
 flags.shot_ready       = 0;
 flags.window           = 0;
 flags.inked            = 0;
 flags.page_drop        = 0;
 flags.kills            = 0;
 flags.regen            = 0;
 flags.non_consentual   = 0;
 flags.d_frames         = 0;
 flags.selected         = 3;
 flags.hiding           = 0;
 flags.hiding_dir       = 0;
 flags.health           = 5;
 flags.pages[0]         = 0;
 flags.pages[1]         = 0;
 flags.pages[2]         = 2;
 flags.pages[3]         = 0;
 flags.pages[4]         = 0;
 flags.charge           = 360;
 flags.charge_skip      = 0;
 flags.spawn            = 0;
 flags.score_multiplier = 1.0;
 flags.last_clock       = 0;
 flags.last_sec         = -1;
 flags.message          = 0;
 flags.message_timing   = 0;

 return;
}









// Ends game upon time-out.
// Player gets a review of their stats
// Player is then booted to the title screen (vars need to be reset)
//
void end_game(int mode)
{

 game_mode = (3 + mode);
 camera.rotation = 0.00;
 camera.zoom     = 1.00;


 do {
     update_and_render();
    } while(!IsKeyDown(KEY_Z));

 PlaySound(sfx[2]);

 do {
     update_and_render();
    } while(IsKeyDown(KEY_Z));


 return;
}






// Out of laziness, check each key and send back anything unique
// Valid keys are A-Z and 0-9. Returns 0 if no button seen
//
int get_initial()
{
 int check = 0;

 if(IsKeyPressed(KEY_A)) { return(65); }

 if(IsKeyPressed(KEY_B))  { return(66); }
 if(IsKeyPressed(KEY_C))  { return(67); }
 if(IsKeyPressed(KEY_D))  { return(68); }
 if(IsKeyPressed(KEY_E))  { return(69); }
 if(IsKeyPressed(KEY_F))  { return(70); }
 if(IsKeyPressed(KEY_G))  { return(71); }

 if(IsKeyPressed(KEY_H))  { return(72); }
 if(IsKeyPressed(KEY_I))  { return(73); }
 if(IsKeyPressed(KEY_J))  { return(74); }
 if(IsKeyPressed(KEY_K))  { return(75); }
 if(IsKeyPressed(KEY_L))  { return(76); }
 if(IsKeyPressed(KEY_M))  { return(77); }
 if(IsKeyPressed(KEY_N))  { return(78); }
 if(IsKeyPressed(KEY_O))  { return(79); }
 if(IsKeyPressed(KEY_P))  { return(80); }

 if(IsKeyPressed(KEY_Q))  { return(81); }
 if(IsKeyPressed(KEY_R))  { return(82); }
 if(IsKeyPressed(KEY_S))  { return(83); }
 if(IsKeyPressed(KEY_T))  { return(84); }
 if(IsKeyPressed(KEY_U))  { return(85); }
 if(IsKeyPressed(KEY_V))  { return(86); }
 if(IsKeyPressed(KEY_W))  { return(87); }
 if(IsKeyPressed(KEY_X))  { return(88); }
 if(IsKeyPressed(KEY_Y))  { return(89); }
 if(IsKeyPressed(KEY_Z))  { return(90); }

 if(IsKeyPressed(KEY_ZERO))  { return(48); }
 if(IsKeyPressed(KEY_ONE))   { return(49); }
 if(IsKeyPressed(KEY_TWO))   { return(50); }
 if(IsKeyPressed(KEY_THREE)) { return(51); }
 if(IsKeyPressed(KEY_FOUR))  { return(52); }
 if(IsKeyPressed(KEY_FIVE))  { return(53); }
 if(IsKeyPressed(KEY_SIX))   { return(54); }
 if(IsKeyPressed(KEY_SEVEN)) { return(55); }
 if(IsKeyPressed(KEY_EIGHT)) { return(56); }
 if(IsKeyPressed(KEY_NINE))  { return(57); }

 return(check);
}










// NOTE: Allegro-style CPU blitting operation
//
void blit(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 ImageDraw(&dest, src, s, d, WHITE);

 return;
}






// Vertically-flipped blit.
//
void blit_v(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 Image subs = ImageFromImage(src, s);
 ImageFlipVertical(&subs);

 s.x = 0;
 s.y = 0;
 ImageDraw(&dest, subs, s, d, WHITE);

 UnloadImage(subs);

 return;
}




// Horizontally-flipped blit.
//
void blit_h(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 Image subs = ImageFromImage(src, s);
 ImageFlipHorizontal(&subs);

 s.x = 0;
 s.y = 0;
 ImageDraw(&dest, subs, s, d, WHITE);

 UnloadImage(subs);

 return;
}




void assign_animation(int who, int anim, int loops)
{
 // Sanity Check
 //
 if(who < 0 || who >= MAX_ACTORS) { return; }

 actors[who].anim_set    = anim;
 actors[who].anim_step   = 0;
 actors[who].anim_timing = 0;
 actors[who].anim_loop   = loops;

 return;
}





void kill_animation(int who)
{
 // Sanity Check
 //
 if(who < 0 || who >= MAX_ACTORS) { return; }

 actors[who].anim_set    = 0;
 actors[who].anim_step   = 0;
 actors[who].anim_timing = 0;
 actors[who].anim_loop   = 0;

 return;
}






void show_stats()
{
 bool exit = 0;
 bool enter = 1;

 do {

    if(enter)  { if(!IsKeyDown(KEY_X)) { enter = 0; } }
    if(!enter) { if(IsKeyDown(KEY_X))  { exit  = 1; } }

    update_and_render();

    } while(!exit);

 return;
}







// Draws game over score summary
//
void draw_summary(int mode)
{
 int txt_x     = 0;
 float pulse   = 0.0;
 Vector2 len   = { 0, 0 };

 EndMode2D();

 // Draw box texture as background
 //
 Rectangle tex_s = { box_tex_x, box_tex_y, 64, 32 };
 Rectangle tex_d = { 0, 0, SCREEN_W, SCREEN_H };
 DrawTextureTiled(box_tex, tex_s, tex_d, (Vector2){0,0}, 0.0, 3.0, Fade(WHITE, 0.90));


 // Game Over Screen Title (duh)
 //
 if(!mode) {
     len   = MeasureTextEx(font1, "GAME  OVER", (font1.baseSize * 4), 1);
     txt_x = (SCREEN_W / 2) - (len.x / 2);

     DrawTextEx(font1, "GAME  OVER", (Vector2){txt_x, 35}, font1.baseSize * 4, 1, WHITE);

     len   = MeasureTextEx(font1, "YOU HAVE FAILED TO SAVE YOUR HOME", (font1.baseSize * 2), 1);
     txt_x = (SCREEN_W / 2) - (len.x / 2);
     sprintf(custom_text, "YOU HAVE FAILED TO SAVE YOUR HOME");
     DrawTextEx(font1, custom_text, (Vector2){txt_x, 200}, font1.baseSize * 2, 1, WHITE);


     len   = MeasureTextEx(font1, "AND ARE NOW A TASTY PROTEIN SNACK", (font1.baseSize * 2), 1);
     txt_x = (SCREEN_W / 2) - (len.x / 2);
     sprintf(custom_text, "AND ARE NOW A TASTY PROTEIN SNACK");
     DrawTextEx(font1, custom_text, (Vector2){txt_x, 300 }, font1.baseSize * 2, 1, WHITE);
           }

 else {
     len   = MeasureTextEx(font1, "WINNING!", (font1.baseSize * 4), 1);
     txt_x = (SCREEN_W / 2) - (len.x / 2);

     DrawTextEx(font1, "WINNING!", (Vector2){txt_x, 35}, font1.baseSize * 4, 1, YELLOW);

     len   = MeasureTextEx(font1, "YOU'VE SAVED YOUR HOME AND VENTURED TO SPACE", (font1.baseSize * 2), 1);
     txt_x = (SCREEN_W / 2) - (len.x / 2);
     sprintf(custom_text, "YOU'VE SAVED YOUR HOME AND VENTURED TO SPACE");
     DrawTextEx(font1, custom_text, (Vector2){txt_x, 200}, font1.baseSize * 2, 1, SCORE_GREEN);


     len   = MeasureTextEx(font1, "THE GREAT TENTACLE GODS BOW BEFORE YOU", (font1.baseSize * 2), 1);
     txt_x = (SCREEN_W / 2) - (len.x / 2);
     sprintf(custom_text, "THE GREAT TENTACLE GODS BOW BEFORE YOU");
     DrawTextEx(font1, custom_text, (Vector2){txt_x, 300 }, font1.baseSize * 2, 1, SCORE_GREEN);
      }




 // Press 'Z' to continue
 //
 len   = MeasureTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (font1.baseSize * 2), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);


 pulse = sin(anims[4] * rad_conv) * 0.50;
 DrawTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (Vector2){txt_x, SCREEN_H - 65}, font1.baseSize * 2, 1, Fade(WHITE, 0.50 + pulse));

 BeginMode2D(camera);

 return;
}






// Draws ghetto-ass tutorial
//
void draw_tutorial()
{
 int txt_x   = 0;
 float pulse = 0.0;
 Vector2 len = { 0, 0 };

 EndMode2D();

 // Draw box texture as background
 //
 Rectangle tex_s = { box_tex_x,box_tex_y, 64, 32 };
 Rectangle tex_d = { 0, 0, SCREEN_W, SCREEN_H };
 DrawTextureTiled(box_tex, tex_s, tex_d, (Vector2){0,0}, 0.0, 3.0, Fade(WHITE, 0.90));


 len   = MeasureTextEx(font1, "INSTRUCTIONS", (font1.baseSize * 4), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);

 DrawTextEx(font1, "INSTRUCTIONS", (Vector2){txt_x, 44}, font1.baseSize * 4, 1, WHITE);


 // NOTE: Next project, move this into a routine to clean this janky shit up
 //
 len   = MeasureTextEx(font1, "YOU ARE A HUMBLE PUFFER FISH -- WHO LIVES IN A RAIL CAR.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "YOU ARE A HUMBLE PUFFER FISH -- WHO LIVES IN A RAIL CAR.", (Vector2){txt_x, 150}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "YOU ARE CONSTANTLY TERRORIZED BY PREDATORS. ESCAPE IS THE ONLY OPTION.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "YOU ARE CONSTANTLY TERRORIZED BY PREDATORS. ESCAPE IS THE ONLY OPTION.", (Vector2){txt_x, 210}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "LEGENDS SPEAK OF FOUR JOURNAL PAGES THAT GRANT WISHES WHEN COMBINED.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "LEGENDS SPEAK OF FOUR JOURNAL PAGES THAT GRANT WISHES WHEN COMBINED.", (Vector2){txt_x, 240}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "YOU HAVE ONE PAGE ALREADY -- BUT IT IS DAMAGED.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "YOU HAVE ONE PAGE ALREADY -- BUT IT IS DAMAGED.", (Vector2){txt_x, 270}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "PRESS [Z] OVER A WINDOW TO HIDE IN THE RAIL CAR!", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "PRESS [Z] OVER A WINDOW TO HIDE IN THE RAIL CAR!", (Vector2){txt_x, 330}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "YOU CAN SWAP JOURNAL PAGES IN THE RAIL CAR. EACH ONE IS POWERFUL!", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "YOU CAN SWAP JOURNAL PAGES IN THE RAIL CAR. EACH ONE IS POWERFUL!", (Vector2){txt_x, 360}, font1.baseSize * 1, 1, YELLOW);


 len   = MeasureTextEx(font1, "HOLD [X] TO PUFF UP AND DEFEND YOURSELF AGAINST ENEMIES.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "HOLD [X] TO PUFF UP AND DEFEND YOURSELF AGAINST ENEMIES.", (Vector2){txt_x, 390}, font1.baseSize * 1, 1, GREEN);


 len   = MeasureTextEx(font1, "THE GAME ENDS WHEN YOU COLLECT ALL JOURNAL PAGES, OR RUN OUT OF HEALTH.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "THE GAME ENDS WHEN YOU COLLECT ALL JOURNAL PAGES, OR RUN OUT OF HEALTH.", (Vector2){txt_x, 460}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "EXPLORE. BE BOLD. BUT BEWARE THE HORNY SQUID...", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "EXPLORE. BE BOLD. BUT BEWARE THE HORNY SQUID...", (Vector2){txt_x, 670}, font1.baseSize * 1, 1, YELLOW);




 // Press 'Z' to continue
 //
 len   = MeasureTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (font1.baseSize * 2), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);

 pulse = sin(anims[4] * rad_conv) * 0.50;
 DrawTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (Vector2){txt_x, SCREEN_H - 65}, font1.baseSize * 2, 1, Fade(WHITE, 0.50 + pulse));

 BeginMode2D(camera);

 return;
}






// NOTE: Checks two floats and returns 1 if they are within range
//
int check_floats(float one, float two, float range)
{

 float check = fabs(one - two);

 if(check <= range) { return(1); }

 return(0);
}




// NOTE: Checks against a known actor (puppet, lamp, etc)
//       and returns TRUE if they are within ? units of each other.
//
int check_collision(int who, int target, int radius, int z_adjust)
{

 if(who < 0 || who >= MAX_ACTORS) { printf("ERROR: Who OOB in %s", __func__); return(0); }
 if(target < 0 || target >= MAX_ACTORS) { printf("ERROR: Target OOB in %s", __func__); return(0); }

 int dist = abs(FR_2d_dist(actors[who].pos.x, (actors[who].pos.y - actors[who].pos.z),
                       actors[target].pos.x, (actors[target].pos.y - actors[target].pos.z - z_adjust)));

 if(dist < radius) { return(1); }
 else              { return(0); }
}






void push_rect(Rectangle *rect, float x, float y, float w, float h)
{

 rect->x      = x;
 rect->y      = y;
 rect->width  = w;
 rect->height = h;

 return;
}





// NOTE: Janky way to kill off any squid that have attacked
//
void kill_squid()
{
 int i = 0;

 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled && actors[i].owner == puppet) {
         actors[i].team   = 6;
         actors[i].cel_x  = 4;
         actors[i].effect = 7;
         actors[i].state  = 18;
         actors[i].owner  = -1;
                                                        }
                             }

 PlaySound(sfx[3]);

 return;
}




void kill_hook(int who)
{

 if(who < 0 || who >= MAX_ACTORS) { printf("who OOB in call to %s", __func__); return; }
 actors[who].path.x *= -1;
 actors[who].path.z *= -1;
 actors[who].inert = 1;
 actors[who].team  = 6;
 actors[who].state = 22;

 return;
}





int spawn_brush(int x, int y, Color col, float scale)
{
 int who = -1;

 who = spawn_actor(0, 0, 0, 0, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 42;
     actors[who].scale   = scale;
     actors[who].state   = 0;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y;
     actors[who].pos.z   = 0;
     actors[who].effect  = 2;
     actors[who].cel     = tex_brush;
     actors[who]._size_w = 960;
     actors[who]._size_h = 32;
     actors[who].stamina = 1000;
     actors[who].color   = col;
     actors[who].enabled = 1;
               }

 return(who);
}





// Drops a random clump of kelp on the screen
//
void spawn_kelp_patches()
{
 int i      = 0;
 int k      = 0;
 int y      = 0;
 int top    = SCREEN_H - 320; // was 330
 int bottom = SCREEN_H - 100;
 float grad = 0.0;

 // Start with a smaller range, restricted to the back portion of the scene
 //
 for(i=0; i<MAX_KELP / 2; i++) {
     y = GetRandomValue(top, SCREEN_H - 200);
     k = spawn_kelp(GetRandomValue(0, (SCREEN_W * 5)), y, KELP_GREEN, 2.0);

     actors[k].scale = 1.0 + scale(actors[k].pos.y, top, bottom, 0.0, 1.5);

     grad = norm_f(actors[k].pos.y, top, bottom);
     actors[k].color = FR_grab_gradient(KELP_BLUE, KELP_GREEN, 0.0, grad);
                               }


 // Spawn full range of kelp
 //
 for(i=0; i<MAX_KELP; i++) {
     // Don't let kept z-fight with the railcar. Looks janky
     //
     y = GetRandomValue(top, bottom);
     if(y >= 799 && y <= 801) { y = 799; }

     k = spawn_kelp(GetRandomValue(0, (SCREEN_W * 5)), y, KELP_GREEN, 2.0);

     actors[k].scale = 1.0 + scale(actors[k].pos.y, top, bottom, 0.0, 1.5);

     grad = norm_f(actors[k].pos.y, top, bottom);
     actors[k].color = FR_grab_gradient(KELP_BLUE, KELP_GREEN, 0.0, grad);
                           }
 return;
}




int spawn_kelp(int x, int y, Color col, float scale)
{
 int who = -1;

 who = spawn_actor(0, 0, 0, 0, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = 10 + quick_rand(20); // 0
     actors[who].team    = 6;
     actors[who].scale   = scale;
     actors[who].state   = 0;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y;
     actors[who].pos.z   = 0;
     actors[who].effect  = 4;
     actors[who].cel     = tex_kelp;
     actors[who]._size_w = 128;
     actors[who]._size_h = 256;

     actors[who].stamina = 1000;
     actors[who].color   = col;
     actors[who].enabled = 1;
               }

 return(who);
}






int spawn_player(int x, int y, int z)
{
 int who = -1;

 who = spawn_actor(0, 0, 0, 0, 1, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 1;
     actors[who].scale   = 1.0;
     actors[who].state   = 0;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y;
     actors[who].pos.z   = z;
     actors[who].cel     = tex_fish;
     actors[who]._size_w = 128;
     actors[who]._size_h = 128;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 return(who);
}




int spawn_railcar(int x, int y, int z)
{
 int who = -1;

 who = spawn_actor(0, 0, 0, 0, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = -7 + quick_rand(14); // was 7
     actors[who].team    = 1;
     actors[who].scale   = 3.0;
     actors[who].state   = 0;
     actors[who].effect  = 8;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y;
     actors[who].pos.z   = z;
     actors[who].cel     = tex_railcar;
     actors[who]._size_w = tex_railcar.width;
     actors[who]._size_h = tex_railcar.height;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 return(who);
}





int spawn_ray(float x, float y, float z)
{
 int who       = -1;
 float rescale = 0.0;

 who = spawn_actor(0, 0, 0, 0, 0, 0.5, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 6;
     actors[who].scale   = 2.0;
     actors[who].state   = 8;
     actors[who].blend   = 0.0;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y;
     actors[who].pos.z   = z;
     actors[who].cel     = tex_rays;
     actors[who]._size_w = 128;
     actors[who]._size_h = 256;
     actors[who].stamina = 180;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 // Rays will randomly walk right, and their speed matches their scale
 // Y Position will also match their scale (kinda)
 //
 rescale = (float)(GetRandomValue(1, 100)) / 100.0;

 actors[who].path.x = 1.0 * (rescale * 1.0);
 actors[who].scale  = 1.0 + (rescale * 2.0);
 actors[who].pos.y  = 500.0 * rescale;

 return(who);
}







// NOTE: type 0 = standard red bullet
//
int spawn_bullet(float x, float y, float z, int type)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, (3 + type), 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 2;
     actors[who].angle   = 0;
     actors[who].v_angle = 0;
     actors[who].v_speed = 4.0;
     actors[who].v_roll  = -1.0 + ((float)GetRandomValue(0, 2000) / 1000.0);
     actors[who].scale   = 2.0;
     actors[who].state   = 5;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 return(who);
}





// NOTE: Scales, rotates, fades out
//       [TYPE] is 0 for normal damage
//       [TYPE] is 1 for boss damage
//
int spawn_damage(float x, float y, float z, bool type)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 6;
     actors[who].angle   = 0;
     actors[who].roll    = -4.0 + ((float)GetRandomValue(0, 8000) / 1000.0);
     actors[who].state   = 10;
     actors[who].cel     = tex_damage;
     actors[who]._size_w = 128;
     actors[who]._size_h = 128;
     actors[who].stamina = 1000;
     actors[who].enabled = 1;

     if(!type) { // Standard damage
         actors[who].color   = WHITE;
         actors[who].scale   = 2.5;
               }
     else {      // Boss damage
         actors[who].color   = GREEN;
         actors[who].scale   = 0.5;
          }
               }

 return(who);
}





// NOTE: Big fish that comes at player from side of screen
//
int spawn_evil_fish(float x, float y, float z, int direction)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 2;
     actors[who].extra   = 1;     // THIS ACTOR CAN BE POKED TO DEATH
     actors[who].scale   = 2.0;
     actors[who].state   = 11;
     actors[who].mode    = 1;     // THIS ACTOR CAN BE SHOT
     actors[who].flip    = 1;
     actors[who].cel     = tex_evil_fish;
     actors[who]._size_w = 64;
     actors[who]._size_h = 64;
     actors[who].stamina = 1200;
     actors[who].color   = WHITE;
     actors[who].path.x  = 4.0 + (float)((float)GetRandomValue(0, 10000) / 10000.0);
     actors[who].enabled = 1;

     if(direction) { actors[who].path.x *= -1.0; actors[who].flip = 0; }
               }

 return(who);
}




// NOTE: SQUID SE.CX IS BEST SE.CX
//
int spawn_squid(float x, float y, float z, int direction)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 2, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team       = 2;
     actors[who].extra      = 1;     // THIS ACTOR CAN BE POKED TO DEATH
     actors[who].mode       = 1;     // THIS ACTOR CAN BE SHOT
     actors[who].scale      = 3.0;
     actors[who].angle      = direction - 225;
     actors[who].last_angle = direction - 225;
     actors[who].state      = 16;
     actors[who].cel        = tex_64x;
     actors[who]._size_w    = 64;
     actors[who]._size_h    = 64;
     actors[who].stamina    = 1200;
     actors[who].color      = WHITE;
     actors[who].enabled    = 1;
               }

 return(who);
}



// NOTE: In Leisure Suit Larry we trust
//
int spawn_black_bar()
{
 int who = -1;

 who = spawn_actor(0, actors[puppet].pos.x, actors[puppet].pos.y + 2, actors[puppet].pos.z - 64, 1, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team       = 6;
     actors[who].scale      = 2.0;
     actors[who].state      = 19;
     actors[who].cel        = tex_censored;
     actors[who]._size_w    = 256;
     actors[who]._size_h    = 128;
     actors[who].stamina    = 600;
     actors[who].color      = WHITE;
     actors[who].enabled    = 1;
               }

 PlaySound(sfx[6]);

 return(who);
}





int spawn_shark(float x, float y, float z)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team       = 2;
     actors[who].extra      = 2;     // THIS ACTOR CAN BE POKED TO DEATH (in the rear)
     actors[who].scale      = 4.0;
     actors[who].angle      = 0;
     actors[who].state      = 30;
     actors[who].y_shift    = 128.0; // THIS ACTOR IS BADLY OFFSET INSIDE LARGE CEL
     actors[who].cel        = tex_shark;
     actors[who]._size_w    = 256;
     actors[who]._size_h    = 256;
     actors[who].stamina    = 3;     // Takes three hits to kill
     actors[who].color      = WHITE;
     actors[who].enabled    = 1;
               }

 return(who);
}




int spawn_octopus(float x, float y, float z)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team       = 2;
     actors[who].extra      = 2;     // THIS ACTOR CAN BE POKED TO DEATH (in the eye)
     actors[who].scale      = 4.0;
     actors[who].angle      = 0;
     actors[who].state      = 44;
     actors[who].cel        = tex_octopus;
     actors[who]._size_w    = 256;
     actors[who]._size_h    = 256;
     actors[who].stamina    = 20;
     actors[who].color      = WHITE;
     actors[who].enabled    = 1;
               }

 return(who);
}




int spawn_octopus_arm(float x, float y, float z)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team       = 2;
     actors[who].scale      = 4.0;
     actors[who].angle      = 0;
     actors[who].v_angle    = 0;
     actors[who].state      = 40;
     actors[who].cel        = tex_arm;
     actors[who]._size_w    = 512;
     actors[who]._size_h    = 32;
     actors[who].stamina    = 1200;
     actors[who].color      = WHITE;
     actors[who].enabled    = 1;
               }

 return(who);
}





// NOTE: Fishing hook that drifts lazily in the ocean
//       [SPECIAL] indicates the hook has a journal page on the end of the line
//
int spawn_hook(float x, float y, float z, bool special)
{
 int who  = -1;
 int page = -1;

 who = spawn_actor(0, x, y, z, 1, -1.0, 0.0, -4.0);

 if(who != -1) {
     actors[who].team    = 2;
     actors[who].scale   = 1.5;
     actors[who].state   = 20;
     actors[who].blend   = 0.0;
     actors[who].v_speed = 1.0;
     actors[who].v_roll  = 0.25;
     actors[who].angle   = 20;
     actors[who].effect  = 5;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 500;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 if(special) {
     actors[who].stamina = INFINITE;
     page = spawn_journal_page(x, y, z, 0, 0);
     if(page != -1) { actors[page].following = who; }
             }

 return(who);
}





int spawn_ink_blot(float x, float y, float z)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 3, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 3;
     actors[who].scale   = 1.0 + (float)(((float)quick_rand(2000)) / 1000.0);
     actors[who].state   = 3;
     actors[who].effect  = 1;
     actors[who].flicker = 1;
     actors[who].v_speed = 2.0 + (float)quick_rand(300) / 100.0;
     actors[who].v_angle = quick_rand(360);
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 200;
     actors[who].color   = BLACK;

     actors[who].enabled = 1;
               }

 return(who);
}




int spawn_radiance(float x, float y, float z, bool dir)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 1, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 3;
     actors[who].scale   = 1.0;
     actors[who].state   = 5;
     actors[who].flicker = 1;
     actors[who].v_speed = 8.0;
     actors[who].cel     = tex_64x;
     actors[who]._size_w = 64;
     actors[who]._size_h = 64;
     actors[who].stamina = 60;
     actors[who].color   = WHITE;

     if(dir) { // Right shot
         actors[who].angle   = 270.0;
         actors[who].v_angle = 90.0;
             }
     else {    // Left shot
         actors[who].angle   = 90.0;
         actors[who].v_angle = 270.0;
          }

     actors[who].enabled = 1;
               }

 PlaySound(sfx[5]);

 return(who);
}





// NOTE: Scales, rotates, fades out
//
int spawn_journal_page(float x, float y, float z, int page, bool rainbow)
{
 int who = -1;
 int wat = -1;

 // Start with rainbow star background that rotates lazily
 //
 if(rainbow) {
     who = spawn_actor(0, x, y, z, 0, 0.0, 0.0, 0.0);

     if(who != -1) {
         actors[who].team    = 6;
         actors[who].angle   = 0;
         actors[who].roll    = 1.0;
         actors[who].scale   = 3.0;
         actors[who].state   = 0;
         actors[who].cel     = tex_rainbow;
         actors[who]._size_w = 128;
         actors[who]._size_h = 128;
         actors[who].stamina = 1000;
         actors[who].color   = WHITE;
         actors[who].enabled = 1;
                   }
             }


 // Spawns actual journal page
 //
 wat = spawn_actor(0, 0, 0, 0, page, 0.0, 0.0, 0.0);

 if(wat != -1) {
     actors[wat].team    = 8;
     actors[wat].scale   = 1.0;
     actors[wat].state   = 0;
     actors[wat].event   = page;
     actors[wat].pos.x   = x + 4;
     actors[wat].pos.y   = y + 1;
     actors[wat].pos.z   = z + 128;
     actors[wat].cel     = tex_pages;
     actors[wat]._size_w = 128;
     actors[wat]._size_h = 128;
     actors[wat].stamina = 1000;
     actors[wat].color   = WHITE;
     actors[wat].enabled = 1;
               }

 if(rainbow) { actors[wat].locked_to = who; }

 return(wat);
}





int spawn_thruster_fire(float x, float y, float z)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 6, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 3;
     actors[who].scale   = 3.0;
     actors[who].state   = 2;
     actors[who].effect  = 1;
     actors[who].flicker = 1;
     actors[who].angle   = 180.0;
     actors[who].cel     = tex_64x;
     actors[who]._size_w = 64;
     actors[who]._size_h = 64;
     actors[who].stamina = 1000;

     actors[who].enabled = 1;
               }

 return(who);
}





void good_ending()
{
 bool exit      = 0;
 bool next      = 0;
 bool sound     = 0;
 int  last_tick = 3;


 div_t d;

 // Wait for player to duck into the train
 //
 do {
     update_and_render();
    } while(flags.hiding < 30);



 thrusters[0] = spawn_thruster_fire(actors[railcar].pos.x - 200, actors[railcar].pos.y - 1, actors[railcar].pos.z - 64);
 thrusters[1] = spawn_thruster_fire(actors[railcar].pos.x + 200, actors[railcar].pos.y - 1, actors[railcar].pos.z - 64);

 PlaySound(sfx[18]);

 flags.ending = 1;

 do {
     update_and_render();

     // Ghetto sound tracking for end-sequence
     //
     if(flags.ending < 5150) {
         d = div(flags.ending, 120);
         if(d.quot > last_tick) {
             last_tick = d.quot;
             PlaySound(sfx[17]);
                                }
                             }


     if(flags.ending >= 5300) {
         if(!sound) { PlaySound(sfx[20]); sound = 1; }

         if(IsKeyDown(KEY_Z)) { next = 1; }
         if(next && (!IsKeyDown(KEY_Z))) { PlaySound(sfx[2]); exit = 1; }
                              }

    } while(!exit);

 game_over    = 1;
 flags.ending = 0;

 return;
}





/// UTILITY CODE HERE ------------------------------------------------------------




// NOTE: Basic scaling routine
//       Translates source to scaled
//
float scale(float value, float source_min, float source_max, float scaled_min, float scaled_max)
{
 long double percentage = 0;

 if((source_max - source_min) == 0.000) { return(0); } // If used in framework, signal division by zero

 percentage = (value - source_min) / (source_max - source_min);

 return ((percentage * (scaled_max - scaled_min)) + scaled_min);
}




float degrees_to_radians(float degrees)
{
 float value = 0;

 value = degrees * (PI / 180.00);

 return(value);
}





// NOTE: Displays various signals
//       type 0 = WARNING!
//       type 1 = STRIKE
//
void display_signal(int type)
{
 // Set the UI flag and timer accordingly
 // Setting the timer to 2.00 allows for an extra 100 ticks before the signal fades out
 // Raylib doesn't care if you set alpha over 1.00 for fade, it'll clip :D
 //
 show_signal = type;
 anims[9]    = 2.00;

 return;
}




void buffer_sfx(int sfx_slot, int ticks)
{
 int i = 0;

 for(i=0; i<16; i++) {
     if(sfx_buffer[i][0] == -1) {
         sfx_buffer[i][0] = sfx_slot;
         sfx_buffer[i][1] = ticks;
         return;
                                }

                     }

 printf("Couldn't queue sfx. No slots available\n");

 return;
}






Color FR_grab_gradient(Color c1, Color c2, float banding, float zero_to_one)
{

 Color value = BLANK;

 float b_factor;
 float zto = zero_to_one;

 float final_r;
 float final_g;
 float final_b;

 float d_r = c2.r - c1.r;
 float d_g = c2.g - c1.g;
 float d_b = c2.b - c1.b;

 // for(i=0; i<flags.pingpong; i++) { zto = FR_fold_gradient(zto); }

 // There's a weird rounding error this 0.99 fixes. Normally it'd be 1.0
 //
 if(zto >= 1.0) { zto = 0.99; }
 if(zto < 0.0)  { zto = 0.0;  }


 // b_factor comes out a little worse for wear after being
 // folded. Sometimes 13.0000, sometimes 12.99999. Add and round
 // to eliminate this effect.
 //
 if(banding > 1) {
     b_factor = (zto * banding) + 0.01;
     b_factor = floor(b_factor);

     final_r  = c1.r + (d_r / banding) * (float)b_factor;
     final_g  = c1.g + (d_g / banding) * (float)b_factor;
     final_b  = c1.b + (d_b / banding) * (float)b_factor;

     value.r = (int)final_r;
     value.g = (int)final_g;
     value.b = (int)final_b;
     value.a = (int)255;
                 }

 // No banding = smooth gradient
 //
 else {
     final_r = c1.r + (d_r * zto);
     final_g = c1.g + (d_g * zto);
     final_b = c1.b + (d_b * zto);

     value.r = (int)final_r;
     value.g = (int)final_g;
     value.b = (int)final_b;
     value.a = (int)255;
      }

 return(value);
}




// NOTE: Returns TRUE if actor slot is valid
//
bool valid_actor(int who)
{

 if(who >= 0 && who < MAX_ACTORS) { return(1); }
 else                             { return(0); }
}




// NOTE: Performs normalization of floating point values. Returns 0-1
//
float norm_f(float source, float min, float max)
{

 return((source - min) / (max - min));
}




int quick_rand(int range)
{
 // This has to be a double, or the lib shits itself
 //
 double f_range = range;
 float result = fastR.xoroshiro128p_Range(0.0, f_range);
 return(result);
}



// ------------------------------------------------------------------------------
// FRAMEWORK DOCUMENTATION
//
// NOTE - Returns the angle in degrees (0-360) between two coordinate pairs,
//        with the assumption that zero degrees points directly UP, and rotates
//        clockwise.
//
// ------------------------------------------------------------------------------
//
float FR_2d_angle_360_f(float x1, float y1, float x2, float y2)
{
 float angle = 0;
 float x_diff, y_diff;


 x_diff = (x2 - x1);
 y_diff = (y2 - y1);

 angle = atan2(y_diff, x_diff);
 angle *= (180.00 / M_PI);


 // This produces an angle where the zero point is facing dead left <---
 // So correct this by adding 90 degrees.
 //
 angle += 90.00;


 // Correct the Radians/angle snafu by adding 360 to the total if the result is negative
 // Otherwise you go from 180 to -180 in the middle of your circle. Boo! Hiss!
 //
 if(angle < 0) { angle += 360.00; }

 return(angle);
}




// NOTE: Returns a point, rotated around another point, by so many degrees
//
Vector2 rotate_point_2d(float point_x, float point_y, float around_x, float around_y, float angle)
{
  float s = sin(degrees_to_radians(angle));
  float c = cos(degrees_to_radians(angle));

  Vector2 results = { 0 };
  Vector2 xlated  = { 0 };

  // normalize point to origin
  //
  point_x -= around_x;
  point_y -= around_y;

  // Perform rotation
  //
  xlated.x = (point_x * c) - (point_y * s);
  xlated.y = (point_x * s) + (point_y * c);

  // de-translate point
  //
  results.x = xlated.x + around_x;
  results.y = xlated.y + around_y;

  return(results);
}




// NOTE: Compares player's position to windows, and returns
//       1 if they overlap. Returns 0 is none match
//
int detect_windows()
{
 int i        = 0;
 int dist     = 0;
 int off_x[6] = { 119, 174, 229, 284, 338, 393 };
 float s_x    = actors[railcar].pos.x - (256 * 3); // 3 is scale of sprite
 float s_y    = actors[railcar].pos.y - (105 * 3); // 105 "texels" from bottom to center of window
 float r_y    = actors[railcar].pos.y - (128 * 3); // 128 is half the texture height (origin of rotation)

 Vector2 dest = { 0 };


 // Check adjusted angles
 //
 for(i=0; i<6; i++) {
     dest = rotate_point_2d(s_x + (off_x[i] * 3), s_y, s_x + (256.5 * 3), r_y, actors[railcar].angle);
     dist = FR_2d_dist(dest.x, dest.y, actors[puppet].pos.x, actors[puppet].pos.y - actors[puppet].pos.z - 64);
     if(dist < 30) { return(1); }
                    }

 return(0);
}







#ifdef USE_TEXTBOX


void check_textbox()
{
 int i = 0;
 int len = 0;

 for(i=0; i<MAX_TEXTBOX; i++) {
     if(textbox[i].enabled) {
         switch(textbox[i].mode) {
                     break;

             case 0: // Entering
                     textbox[i].scale += 0.075;
                     if(textbox[i].scale >= 1.00) { textbox[i].scale = 1.00; textbox[i].mode++; }
                     break;

             case 1: // Displaying text
                     len = strlen(textbox[i].msg);
                     if(textbox[i].viewable_text < len) {
                         textbox[i].ticks++;
                         if(textbox[i].ticks > 3) { textbox[i].viewable_text++; PlaySound(sfx[5]); textbox[i].ticks = 0; }
                                                        }
                     else { textbox[i].ticks++; } // Keep counting ticks, in case useful

                     if(textbox[i].duration != -1) {
                         if(textbox[i].ticks > textbox[i].duration) { textbox[i].mode = 2; }
                                                   }
                     break;

             case 2: // Exiting
                     textbox[i].viewable_text = 0;
                     textbox[i].scale -= 0.075;
                     if(textbox[i].scale <= 0.00) { textbox[i].scale = 0.00; textbox[i].enabled = 0; }
                     break;
                                 }

         if(textbox[i].mode < 0) { textbox[i].mode++; } // Pause before beginning, effectively

                            }
                              }

 // Update background texture position
 //
 if(!box_update) {
     box_tex_x--;
     box_tex_x &= 0x3F;

     box_tex_y++;
     box_tex_y &= 0x1F;

     box_update = 1;
                   }

 else { box_update = 0; }


 // Update water texture position
 //
 if(water_update > 60) {
     water_tex_x++;
     water_tex_x &= 0xFF;

     water_tex_y = 0;
     water_update = 0;
                   }

 else { water_update++; }

 return;
}




void trigger_textbox(int slot, int x, int y, int w, int h, int message, int delay, int duration)
{

 printf("TEXTBOX\n");
 // Sanity check slot and message

 textbox[slot].pos.x      = x;
 textbox[slot].pos.y      = y;
 textbox[slot].pos.width  = w;
 textbox[slot].pos.height = h;
 textbox[slot].scale      = 0.0;
 textbox[slot].duration   = duration;
 textbox[slot].mode       = 0 - delay;
 textbox[slot].ticks      = 0;
 textbox[slot].viewable_text = 0;
 textbox[slot].msg        = NULL; //hints[message];
 textbox[slot].enabled    = 1;

 return;
}




// NOTE: Typical usage is to put the box over a character or tile's position
//
void draw_text_box(int slot)
{
 Rectangle dest;
 char strang[80];

 Vector2 text_coords;
 Vector2 text_len;


 if(!textbox[slot].enabled) { return; }
 if(textbox[slot].mode < 0) { return; }


 // Calculate textbox dimensions, etc
 //
 dest.width  = textbox[slot].pos.width  * textbox[slot].scale;
 dest.height = textbox[slot].pos.height * textbox[slot].scale;

 dest.x = textbox[slot].pos.x - (dest.width / 2.0f);
 dest.y = textbox[slot].pos.y - (dest.height / 2.0f);


 // Draw border around box
 //
 DrawRectangleLinesEx(dest, 4, WHITE);


 // Draw tiled texture (happy face) and update anchor coordinates
 //
 Rectangle tex_s = { box_tex_x,box_tex_y, 64, 32 };
 Rectangle tex_d = { dest.x+3, dest.y+3, dest.width - 6, dest.height - 6 };
 DrawTextureTiled(box_tex, tex_s, tex_d, (Vector2){0,0}, 0.0, 3.0, Fade(WHITE, 0.90));


 // Measure text and box and figure out how to center text
 //
 text_len = MeasureTextEx(font3, textbox[slot].msg, (font3.baseSize * 2), 1);

 text_coords.x = dest.x + (dest.width / 2) - (text_len.x / 2);
 text_coords.y = dest.y + (dest.height / 2.0f) - font3.baseSize;


 // Draw characters
 //
 if(textbox[slot].viewable_text > 0) {
     memset(strang, 0, sizeof(strang));
     strncpy(strang, textbox[slot].msg, textbox[slot].viewable_text);
     DrawTextEx(font3, strang, text_coords, (font3.baseSize * 2), 1, WHITE);
                                     }

 return;
}


#endif









#ifdef USE_RTMIDI


void init_midi()
{
 int i = 0;

  try {
    midi.midiin = new RtMidiIn();
  }
  catch ( RtMidiError &error ) {
    error.printMessage();
    exit( EXIT_FAILURE );
  }

 midi.total_ports  = midi.midiin->getPortCount();
 midi.current_port = 0;

 midi.ignore_sysex = 0;
 midi.ignore_timing = 0;
 midi.ignore_active_sensing = 0;

 if(midi.total_ports > 0) {
 midi.midiin->openPort(midi.current_port);

 midi.midiin->ignoreTypes(midi.ignore_sysex, midi.ignore_timing, midi.ignore_active_sensing);

 //log("[ MIDI ] : Ports found = %d", midi.total_ports);
 //log("[ MIDI ] : Reading from source = %s", midi.midiin->getPortName().c_str()); // I'm actually a little surprised that worked
                          }                                                      // Printf can't handle std::strings. Hence, the .c_str()

 else { /*log("[ INIT ] : No MIDI input detected");*/ }


 // Initialize devices with safe values
 //
 for(i=0; i<MAX_KNOBS; i++) {
     midi.knobs[i].id = -1;
     rescale_midi_device_abs(midi.knobs[i], 0, 127, 0, 127);
     rescale_midi_device_abs(midi.pads[i], 0, 127, 0, 127);
                            }

 return;
}






void poll_midi()
{
 int i            = 0;
 int _key         = 0;
 int recheck      = 0;
 double freq_calc = 0.0;

 if(midi.total_ports < 1) { return; } // Nothing to poll

 repoll:

 midi.msg_stamp = midi.midiin->getMessage(&midi.message);
 midi.msg_bytes = midi.message.size();

 if(midi.msg_bytes > 0) {

     ///log("message received");

     // Knob or Pad update
     if(midi.message[0] == 176) {
         ///printf("Item %d, value %d\n", midi.message[1], midi.message[2]);
         for(i=0; i<MAX_KNOBS; i++) {
             if(midi.knobs[i].id == midi.message[1]) {
                 midi.knobs[i].input = midi.message[2];
                 update_midi_knob(i);

                 ///printf("---- knob.scale = %f\n",midi.knobs[i].scale);
                 ///printf("---- knob.s_min = %f\n",midi.knobs[i].s_min);
                 ///printf("---- knob.s_max = %f\n",midi.knobs[i].s_max);
                 ///printf("---- knob.input = %d\n",midi.knobs[i].input);
                 ///printf("---- knob.value = %f\n",midi.knobs[i].value);
                                                     }
                                    }
                                }

     // Key press
     if(midi.message[0] == 144) {
         _key = midi.message[1]; // sanitize this, yo
         freq_calc = (440.0 / 32.0) * pow(2.0, ((double)(_key - 9) / 12.0));
         midi.keys[_key] = 1;

         midi.note_key = _key;
         midi.note_freq = freq_calc;
         midi.note_active = 1;

         ///log("KEY %d PRESSED", _key);
                                }

     // Key release
     if(midi.message[0] == 128) {
         _key = midi.message[1]; // sanitize this, yo
         midi.keys[_key] = 0;
         midi.note_key = 0;
         midi.note_active = 0;

         ///log("KEY %d released", _key);
                                }

     goto repoll;
                        }


 return;
}




// NOTE: For absolute scale devices
//
void rescale_midi_device_abs(device_struct &knob, float raw_min, float raw_max, float scale_min, float scale_max)
{
 knob.input = 0;
 knob.value = scale_min;

 knob.mode  = 0;
 knob.r_min = raw_min;
 knob.r_max = raw_max;
 knob.s_min = scale_min;
 knob.s_max = scale_max;
 knob.scale = 1.00;          // Not used

 return;
}




// NOTE: For relative devices
//
void rescale_midi_device_rel(device_struct &knob, float scale_min, float scale_max, float tick_scale)
{
 knob.input = 0;
 //knob.value = scale_min;

 knob.mode  = 1;
 knob.r_min = 0.0;           // Not used
 knob.r_max = 1.0;           // Not used
 knob.s_min = scale_min;
 knob.s_max = scale_max;
 knob.scale = tick_scale;

 return;
}




void update_midi_knob(int slot)
{
 int i = slot;

     if(!midi.knobs[i].mode) { // Absolute Values
         midi.knobs[i].value = scale(midi.knobs[i].input, midi.knobs[i].r_min, midi.knobs[i].r_max, midi.knobs[i].s_min, midi.knobs[i].s_max);
                             }

     else { // Relative Values
         midi.knobs[i].value += ((float)(midi.knobs[i].input - 64) * midi.knobs[i].scale);
         midi.knobs[i].input = 0;
         if(midi.knobs[i].value < midi.knobs[i].s_min) { midi.knobs[i].value = midi.knobs[i].s_min; }
         if(midi.knobs[i].value > midi.knobs[i].s_max) { midi.knobs[i].value = midi.knobs[i].s_max; }
          }

     // midi.pads[i].value  = scale(midi.pads[i].input, midi.pads[i].r_min, midi.pads[i].r_max, midi.pads[i].s_min, midi.pads[i].s_max);


 return;
}




void draw_knob(float x, float y, float angle, int slot)
{
 Vector2 origin    = { tex_knob.width, tex_knob.height };
 Vector2 len       = { 0 };
 float final_angle = 0.0;

 // Rotate knob to correct angle based off value and scale
 //
 final_angle = -120 + scale(angle, midi.knobs[slot].s_min, midi.knobs[slot].s_max, 0, 243);
 DrawTexturePro(tex_knob, (Rectangle){0, 0, tex_knob.width, tex_knob.height}, (Rectangle){x, y, tex_knob.width * 2, tex_knob.height * 2} , origin, final_angle, WHITE);


 // Draw Actual value above knob
 //
 sprintf(custom_text, "%02.02f", angle);
 len = MeasureTextEx(font3, custom_text, font3.baseSize * 3, 1);
 DrawTextEx(font3, custom_text, (Vector2){ x - (len.x / 2.0), y + 30 }, font3.baseSize * 3, 1, BLACK);

 return;
}





void draw_midi_knobs()
{
 int i = 0;

 DrawRectangle(0, SCREEN_H, SCREEN_W, 300, GRAY);

 // Knobs on Arturia start at 1. Sigh.
 //
 for(i=0; i<8; i++) {
     DrawTextureEx(tex_knob_plate, (Vector2){140 * i, SCREEN_H + 20}, 0, 2.0, WHITE);
     draw_knob((140 * i) + 64, (SCREEN_H + 20) + 68, midi.knobs[i+1].value, i+1);
                    }

 for(i=0; i<8; i++) {
     DrawTextureEx(tex_knob_plate, (Vector2){140 * i, SCREEN_H + 160}, 0, 2.0, WHITE);
     draw_knob((140 * i) + 64, (SCREEN_H + 160) + 68, midi.knobs[i+9].value, i+9);
                    }

 return;
}





void set_knob(int slot, float new_value)
{

 midi.knobs[slot].value = new_value;


 return;
}





// NOTE: Sets up interface for my current Arturia Minilab II profile
//
void init_arturia_profile()
{
 int i = 0;
 int ids[17] = { -1, 112, 74, 71, 76, 77, 93, 73, 75, 114, 18, 19, 16, 17, 91, 79, 72 };

 if(MAX_KNOBS < 17) { exit(0); }

 for(i=0; i<17; i++) {
     rescale_midi_device_rel(midi.knobs[i], 0.0, 100.0, 1.0);
     midi.knobs[i].id = ids[i];
                     }

 rescale_midi_device_rel(midi.knobs[10], 0.0, 360.0, 2.0);
 rescale_midi_device_rel(midi.knobs[11], 0.0, 1.0, 0.01);
 rescale_midi_device_rel(midi.knobs[12], 0.0, 1.0, 0.01);

 rescale_midi_device_rel(midi.knobs[14], 0.0, 360.0, 2.0);
 rescale_midi_device_rel(midi.knobs[15], 0.0, 1.0, 0.01);
 rescale_midi_device_rel(midi.knobs[16], 0.0, 1.0, 0.01);


 rescale_midi_device_rel(midi.knobs[2], 0.0, 360.0, 2.0);
 rescale_midi_device_rel(midi.knobs[3], 0.0, 1.0, 0.01);
 rescale_midi_device_rel(midi.knobs[4], 0.0, 1.0, 0.01);

 rescale_midi_device_rel(midi.knobs[6], 0.0, 360.0, 2.0);
 rescale_midi_device_rel(midi.knobs[7], 0.0, 1.0, 0.01);
 rescale_midi_device_rel(midi.knobs[8], 0.0, 1.0, 0.01);

 return;
}




void save_knobs()
{
 FILE *file;
 int i     = 0;
 int b_val = 0;

 file = fopen("knobs.sav", "wb");

 for(i=0; i<MAX_KNOBS; i++) {
     b_val = (int)midi.knobs[i].mode;
     fwrite((void *)&b_val, 1, sizeof(b_val), file);
     fwrite((void *)&midi.knobs[i].id,    1, sizeof(midi.knobs[i].id),    file);
     fwrite((void *)&midi.knobs[i].r_min, 1, sizeof(midi.knobs[i].r_min), file);
     fwrite((void *)&midi.knobs[i].r_max, 1, sizeof(midi.knobs[i].r_max), file);
     fwrite((void *)&midi.knobs[i].s_min, 1, sizeof(midi.knobs[i].s_min), file);
     fwrite((void *)&midi.knobs[i].s_max, 1, sizeof(midi.knobs[i].s_max), file);
     fwrite((void *)&midi.knobs[i].value, 1, sizeof(midi.knobs[i].value), file);
     fwrite((void *)&midi.knobs[i].scale, 1, sizeof(midi.knobs[i].scale), file);
                            }

 fclose(file);

 return;
}




void load_knobs()
{
 FILE *file;
 int i     = 0;
 int b_val = 0;

 file = fopen("knobs.sav", "rb");

 for(i=0; i<MAX_KNOBS; i++) {
     fread((void *)&b_val, 1, sizeof(b_val), file);
     midi.knobs[i].mode = b_val;

     fread((void *)&midi.knobs[i].id,    1, sizeof(midi.knobs[i].id),    file);
     fread((void *)&midi.knobs[i].r_min, 1, sizeof(midi.knobs[i].r_min), file);
     fread((void *)&midi.knobs[i].r_max, 1, sizeof(midi.knobs[i].r_max), file);
     fread((void *)&midi.knobs[i].s_min, 1, sizeof(midi.knobs[i].s_min), file);
     fread((void *)&midi.knobs[i].s_max, 1, sizeof(midi.knobs[i].s_max), file);
     fread((void *)&midi.knobs[i].value, 1, sizeof(midi.knobs[i].value), file);
     fread((void *)&midi.knobs[i].scale, 1, sizeof(midi.knobs[i].scale), file);
                            }

 fclose(file);

 return;
}

#endif
